/* chess-engine.c generated by valac 0.44.0, the Vala compiler
 * generated from chess-engine.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2014 Michael Catanzaro
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include "libchess.h"
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>

#define TYPE_CHESS_ENGINE (chess_engine_get_type ())
#define CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_ENGINE, ChessEngine))
#define CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_ENGINE, ChessEngineClass))
#define IS_CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_ENGINE))
#define IS_CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_ENGINE))
#define CHESS_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_ENGINE, ChessEngineClass))

typedef struct _ChessEngine ChessEngine;
typedef struct _ChessEngineClass ChessEngineClass;
typedef struct _ChessEnginePrivate ChessEnginePrivate;
enum  {
	CHESS_ENGINE_0_PROPERTY,
	CHESS_ENGINE_READY_PROPERTY,
	CHESS_ENGINE_NUM_PROPERTIES
};
static GParamSpec* chess_engine_properties[CHESS_ENGINE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	CHESS_ENGINE_STARTING_SIGNAL,
	CHESS_ENGINE_READY_CHANGED_SIGNAL,
	CHESS_ENGINE_MOVED_SIGNAL,
	CHESS_ENGINE_RESIGNED_SIGNAL,
	CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL,
	CHESS_ENGINE_ERROR_SIGNAL,
	CHESS_ENGINE_CLAIM_DRAW_SIGNAL,
	CHESS_ENGINE_OFFER_DRAW_SIGNAL,
	CHESS_ENGINE_NUM_SIGNALS
};
static guint chess_engine_signals[CHESS_ENGINE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessEngine {
	GObject parent_instance;
	ChessEnginePrivate * priv;
};

struct _ChessEngineClass {
	GObjectClass parent_class;
	void (*process_input) (ChessEngine* self, gchar* data, gint data_length1);
	void (*start_game) (ChessEngine* self);
	void (*report_move) (ChessEngine* self, ChessMove* move);
	void (*do_undo) (ChessEngine* self);
	void (*request_move) (ChessEngine* self);
};

struct _ChessEnginePrivate {
	gchar* binary;
	gchar** args;
	gint args_length1;
	gint _args_size_;
	guint delay_seconds;
	guint pending_move_source_id;
	GPid pid;
	gint stdin_fd;
	gint stderr_fd;
	GIOChannel* stdout_channel;
	guint stdout_watch_id;
	gboolean started;
	gboolean _ready;
};

static gint ChessEngine_private_offset;
static gpointer chess_engine_parent_class = NULL;

GType chess_engine_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessEngine, g_object_unref)
void chess_engine_process_input (ChessEngine* self,
                                 gchar* data,
                                 gint data_length1);
static void chess_engine_real_process_input (ChessEngine* self,
                                      gchar* data,
                                      gint data_length1);
ChessEngine* chess_engine_construct (GType object_type,
                                     const gchar* binary,
                                     gchar** args,
                                     gint args_length1,
                                     guint delay_seconds);
static gchar** _vala_array_dup15 (gchar** self,
                           int length);
gboolean chess_engine_start (ChessEngine* self);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void chess_engine_engine_stopped_cb (ChessEngine* self,
                                     GPid pid);
static void _chess_engine_engine_stopped_cb_gchild_watch_func (GPid pid,
                                                        gint status,
                                                        gpointer self);
static gboolean chess_engine_read_cb (ChessEngine* self,
                               GIOChannel* source,
                               GIOCondition condition);
static gboolean _chess_engine_read_cb_gio_func (GIOChannel* source,
                                         GIOCondition condition,
                                         gpointer self);
void chess_engine_stop (ChessEngine* self,
                        gboolean kill_engine);
void chess_engine_start_game (ChessEngine* self);
static void chess_engine_real_start_game (ChessEngine* self);
void chess_engine_report_move (ChessEngine* self,
                               ChessMove* move);
static void chess_engine_real_report_move (ChessEngine* self,
                                    ChessMove* move);
void chess_engine_do_undo (ChessEngine* self);
static void chess_engine_real_do_undo (ChessEngine* self);
void chess_engine_request_move (ChessEngine* self);
static void chess_engine_real_request_move (ChessEngine* self);
void chess_engine_move (ChessEngine* self);
static gboolean __lambda4_ (ChessEngine* self);
static gboolean ___lambda4__gsource_func (gpointer self);
void chess_engine_undo (ChessEngine* self);
void chess_engine_write (ChessEngine* self,
                         gchar* data,
                         gint data_length1);
void chess_engine_write_line (ChessEngine* self,
                              const gchar* line);
gboolean chess_engine_get_ready (ChessEngine* self);
void chess_engine_set_ready (ChessEngine* self,
                             gboolean value);
static void chess_engine_finalize (GObject * obj);
static void _vala_chess_engine_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_chess_engine_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
chess_engine_get_instance_private (ChessEngine* self)
{
	return G_STRUCT_MEMBER_P (self, ChessEngine_private_offset);
}

static void
chess_engine_real_process_input (ChessEngine* self,
                                 gchar* data,
                                 gint data_length1)
{
}

void
chess_engine_process_input (ChessEngine* self,
                            gchar* data,
                            gint data_length1)
{
#line 29 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->process_input (self, data, data_length1);
#line 194 "chess-engine.c"
}

static gchar**
_vala_array_dup15 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
#line 57 "../src/chess-engine.vala"
	result = g_new0 (gchar*, length + 1);
#line 57 "../src/chess-engine.vala"
	for (i = 0; i < length; i++) {
#line 207 "chess-engine.c"
		gchar* _tmp0_;
#line 57 "../src/chess-engine.vala"
		_tmp0_ = g_strdup (self[i]);
#line 57 "../src/chess-engine.vala"
		result[i] = _tmp0_;
#line 213 "chess-engine.c"
	}
#line 57 "../src/chess-engine.vala"
	return result;
#line 217 "chess-engine.c"
}

ChessEngine*
chess_engine_construct (GType object_type,
                        const gchar* binary,
                        gchar** args,
                        gint args_length1,
                        guint delay_seconds)
{
	ChessEngine * self = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 54 "../src/chess-engine.vala"
	g_return_val_if_fail (binary != NULL, NULL);
#line 54 "../src/chess-engine.vala"
	self = (ChessEngine*) g_object_new (object_type, NULL);
#line 56 "../src/chess-engine.vala"
	_tmp0_ = g_strdup (binary);
#line 56 "../src/chess-engine.vala"
	_g_free0 (self->priv->binary);
#line 56 "../src/chess-engine.vala"
	self->priv->binary = _tmp0_;
#line 57 "../src/chess-engine.vala"
	_tmp1_ = (args != NULL) ? _vala_array_dup15 (args, args_length1) : ((gpointer) args);
#line 57 "../src/chess-engine.vala"
	_tmp1__length1 = args_length1;
#line 57 "../src/chess-engine.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_free), NULL);
#line 57 "../src/chess-engine.vala"
	self->priv->args = _tmp1_;
#line 57 "../src/chess-engine.vala"
	self->priv->args_length1 = _tmp1__length1;
#line 57 "../src/chess-engine.vala"
	self->priv->_args_size_ = self->priv->args_length1;
#line 58 "../src/chess-engine.vala"
	self->priv->delay_seconds = delay_seconds;
#line 54 "../src/chess-engine.vala"
	return self;
#line 257 "chess-engine.c"
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 75 "../src/chess-engine.vala"
	if ((*length) == (*size)) {
#line 75 "../src/chess-engine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 75 "../src/chess-engine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 272 "chess-engine.c"
	}
#line 75 "../src/chess-engine.vala"
	(*array)[(*length)++] = value;
#line 75 "../src/chess-engine.vala"
	(*array)[*length] = NULL;
#line 278 "chess-engine.c"
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 76 "../src/chess-engine.vala"
	if ((*length) == (*size)) {
#line 76 "../src/chess-engine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 76 "../src/chess-engine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 293 "chess-engine.c"
	}
#line 76 "../src/chess-engine.vala"
	(*array)[(*length)++] = value;
#line 76 "../src/chess-engine.vala"
	(*array)[*length] = NULL;
#line 299 "chess-engine.c"
}

static void
_chess_engine_engine_stopped_cb_gchild_watch_func (GPid pid,
                                                   gint status,
                                                   gpointer self)
{
#line 91 "../src/chess-engine.vala"
	chess_engine_engine_stopped_cb ((ChessEngine*) self, pid);
#line 309 "chess-engine.c"
}

static gboolean
_chess_engine_read_cb_gio_func (GIOChannel* source,
                                GIOCondition condition,
                                gpointer self)
{
	gboolean result;
	result = chess_engine_read_cb ((ChessEngine*) self, source, condition);
#line 103 "../src/chess-engine.vala"
	return result;
#line 321 "chess-engine.c"
}

gboolean
chess_engine_start (ChessEngine* self)
{
	gboolean result = FALSE;
	gchar** argv = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint stdout_fd = 0;
	GIOChannel* _tmp18_;
	GIOChannel* _tmp24_;
	GIOChannel* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 66 "../src/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 66 "../src/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->pid == ((GPid) 0), "pid == 0", FALSE);
#line 66 "../src/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stdout_watch_id == ((guint) 0), "stdout_watch_id == 0", FALSE);
#line 66 "../src/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stdin_fd == -1, "stdin_fd == -1", FALSE);
#line 66 "../src/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stderr_fd == -1, "stderr_fd == -1", FALSE);
#line 66 "../src/chess-engine.vala"
	_vala_return_val_if_fail (!self->priv->started, "!started", FALSE);
#line 73 "../src/chess-engine.vala"
	_tmp0_ = self->priv->binary;
#line 73 "../src/chess-engine.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 73 "../src/chess-engine.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 73 "../src/chess-engine.vala"
	_tmp2_[0] = _tmp1_;
#line 73 "../src/chess-engine.vala"
	argv = _tmp2_;
#line 73 "../src/chess-engine.vala"
	argv_length1 = 1;
#line 73 "../src/chess-engine.vala"
	_argv_size_ = argv_length1;
#line 74 "../src/chess-engine.vala"
	_tmp3_ = self->priv->args;
#line 74 "../src/chess-engine.vala"
	_tmp3__length1 = self->priv->args_length1;
#line 373 "chess-engine.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 74 "../src/chess-engine.vala"
		arg_collection = _tmp3_;
#line 74 "../src/chess-engine.vala"
		arg_collection_length1 = _tmp3__length1;
#line 74 "../src/chess-engine.vala"
		for (arg_it = 0; arg_it < _tmp3__length1; arg_it = arg_it + 1) {
#line 385 "chess-engine.c"
			gchar* _tmp4_;
			gchar* arg = NULL;
#line 74 "../src/chess-engine.vala"
			_tmp4_ = g_strdup (arg_collection[arg_it]);
#line 74 "../src/chess-engine.vala"
			arg = _tmp4_;
#line 392 "chess-engine.c"
			{
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				gchar* _tmp7_;
#line 75 "../src/chess-engine.vala"
				_tmp5_ = argv;
#line 75 "../src/chess-engine.vala"
				_tmp5__length1 = argv_length1;
#line 75 "../src/chess-engine.vala"
				_tmp6_ = arg;
#line 75 "../src/chess-engine.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 75 "../src/chess-engine.vala"
				_vala_array_add1 (&argv, &argv_length1, &_argv_size_, _tmp7_);
#line 74 "../src/chess-engine.vala"
				_g_free0 (arg);
#line 410 "chess-engine.c"
			}
		}
	}
#line 76 "../src/chess-engine.vala"
	_tmp8_ = argv;
#line 76 "../src/chess-engine.vala"
	_tmp8__length1 = argv_length1;
#line 76 "../src/chess-engine.vala"
	_vala_array_add2 (&argv, &argv_length1, &_argv_size_, NULL);
#line 420 "chess-engine.c"
	{
		gchar** _tmp9_;
		gint _tmp9__length1;
		GPid _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
#line 81 "../src/chess-engine.vala"
		_tmp9_ = argv;
#line 81 "../src/chess-engine.vala"
		_tmp9__length1 = argv_length1;
#line 81 "../src/chess-engine.vala"
		g_spawn_async_with_pipes (NULL, _tmp9_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_inner_error0_);
#line 81 "../src/chess-engine.vala"
		self->priv->pid = _tmp10_;
#line 81 "../src/chess-engine.vala"
		self->priv->stdin_fd = _tmp11_;
#line 81 "../src/chess-engine.vala"
		stdout_fd = _tmp12_;
#line 81 "../src/chess-engine.vala"
		self->priv->stderr_fd = _tmp13_;
#line 81 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 444 "chess-engine.c"
			gboolean _tmp14_ = FALSE;
#line 81 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 448 "chess-engine.c"
				goto __catch2_g_spawn_error;
			}
#line 81 "../src/chess-engine.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 81 "../src/chess-engine.vala"
			return _tmp14_;
#line 459 "chess-engine.c"
		}
	}
	goto __finally2;
	__catch2_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 79 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 79 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 87 "../src/chess-engine.vala"
		_tmp15_ = e;
#line 87 "../src/chess-engine.vala"
		_tmp16_ = _tmp15_->message;
#line 87 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:87: Failed to execute chess engine: %s\n", _tmp16_);
#line 88 "../src/chess-engine.vala"
		result = FALSE;
#line 88 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 88 "../src/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../src/chess-engine.vala"
		return result;
#line 486 "chess-engine.c"
	}
	__finally2:
#line 79 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 491 "chess-engine.c"
		gboolean _tmp17_ = FALSE;
#line 79 "../src/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 79 "../src/chess-engine.vala"
		return _tmp17_;
#line 501 "chess-engine.c"
	}
#line 91 "../src/chess-engine.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->pid, _chess_engine_engine_stopped_cb_gchild_watch_func, g_object_ref (self), g_object_unref);
#line 93 "../src/chess-engine.vala"
	_tmp18_ = g_io_channel_unix_new (stdout_fd);
#line 93 "../src/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 93 "../src/chess-engine.vala"
	self->priv->stdout_channel = _tmp18_;
#line 511 "chess-engine.c"
	{
		GIOChannel* _tmp19_;
#line 96 "../src/chess-engine.vala"
		_tmp19_ = self->priv->stdout_channel;
#line 96 "../src/chess-engine.vala"
		g_io_channel_set_flags (_tmp19_, G_IO_FLAG_NONBLOCK, &_inner_error0_);
#line 96 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 520 "chess-engine.c"
			gboolean _tmp20_ = FALSE;
#line 96 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 524 "chess-engine.c"
				goto __catch3_g_io_channel_error;
			}
#line 96 "../src/chess-engine.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 96 "../src/chess-engine.vala"
			return _tmp20_;
#line 535 "chess-engine.c"
		}
	}
	goto __finally3;
	__catch3_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 94 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 94 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 100 "../src/chess-engine.vala"
		_tmp21_ = e;
#line 100 "../src/chess-engine.vala"
		_tmp22_ = _tmp21_->message;
#line 100 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:100: Failed to set input from chess engine to non-bl" \
"ocking: %s", _tmp22_);
#line 94 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 556 "chess-engine.c"
	}
	__finally3:
#line 94 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 561 "chess-engine.c"
		gboolean _tmp23_ = FALSE;
#line 94 "../src/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../src/chess-engine.vala"
		return _tmp23_;
#line 571 "chess-engine.c"
	}
#line 102 "../src/chess-engine.vala"
	_tmp24_ = self->priv->stdout_channel;
#line 102 "../src/chess-engine.vala"
	g_io_channel_set_close_on_unref (_tmp24_, TRUE);
#line 103 "../src/chess-engine.vala"
	_tmp25_ = self->priv->stdout_channel;
#line 103 "../src/chess-engine.vala"
	self->priv->stdout_watch_id = g_io_add_watch (_tmp25_, G_IO_IN, _chess_engine_read_cb_gio_func, self);
#line 105 "../src/chess-engine.vala"
	self->priv->started = TRUE;
#line 106 "../src/chess-engine.vala"
	g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_STARTING_SIGNAL], 0);
#line 108 "../src/chess-engine.vala"
	result = TRUE;
#line 108 "../src/chess-engine.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/chess-engine.vala"
	return result;
#line 591 "chess-engine.c"
}

static void
chess_engine_engine_stopped_cb (ChessEngine* self,
                                GPid pid)
{
#line 111 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/chess-engine.vala"
	g_spawn_close_pid (pid);
#line 119 "../src/chess-engine.vala"
	if (self->priv->pid == pid) {
#line 121 "../src/chess-engine.vala"
		chess_engine_stop (self, FALSE);
#line 122 "../src/chess-engine.vala"
		g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL], 0);
#line 608 "chess-engine.c"
	}
}

static void
chess_engine_real_start_game (ChessEngine* self)
{
#line 126 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_start_game'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 126 "../src/chess-engine.vala"
	return;
#line 619 "chess-engine.c"
}

void
chess_engine_start_game (ChessEngine* self)
{
#line 126 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->start_game (self);
#line 629 "chess-engine.c"
}

static void
chess_engine_real_report_move (ChessEngine* self,
                               ChessMove* move)
{
#line 128 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_report_move'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 128 "../src/chess-engine.vala"
	return;
#line 640 "chess-engine.c"
}

void
chess_engine_report_move (ChessEngine* self,
                          ChessMove* move)
{
#line 128 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->report_move (self, move);
#line 651 "chess-engine.c"
}

static void
chess_engine_real_do_undo (ChessEngine* self)
{
#line 130 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_do_undo'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 130 "../src/chess-engine.vala"
	return;
#line 661 "chess-engine.c"
}

void
chess_engine_do_undo (ChessEngine* self)
{
#line 130 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->do_undo (self);
#line 671 "chess-engine.c"
}

static void
chess_engine_real_request_move (ChessEngine* self)
{
#line 132 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_request_move'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 132 "../src/chess-engine.vala"
	return;
#line 681 "chess-engine.c"
}

void
chess_engine_request_move (ChessEngine* self)
{
#line 132 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->request_move (self);
#line 691 "chess-engine.c"
}

static gboolean
__lambda4_ (ChessEngine* self)
{
	gboolean result = FALSE;
#line 137 "../src/chess-engine.vala"
	self->priv->pending_move_source_id = (guint) 0;
#line 138 "../src/chess-engine.vala"
	chess_engine_request_move (self);
#line 139 "../src/chess-engine.vala"
	result = G_SOURCE_REMOVE;
#line 139 "../src/chess-engine.vala"
	return result;
#line 706 "chess-engine.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((ChessEngine*) self);
#line 136 "../src/chess-engine.vala"
	return result;
#line 716 "chess-engine.c"
}

void
chess_engine_move (ChessEngine* self)
{
#line 134 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/chess-engine.vala"
	self->priv->pending_move_source_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, self->priv->delay_seconds, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 726 "chess-engine.c"
}

void
chess_engine_undo (ChessEngine* self)
{
#line 143 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/chess-engine.vala"
	if (self->priv->pending_move_source_id != ((guint) 0)) {
#line 147 "../src/chess-engine.vala"
		g_source_remove (self->priv->pending_move_source_id);
#line 148 "../src/chess-engine.vala"
		self->priv->pending_move_source_id = (guint) 0;
#line 740 "chess-engine.c"
	}
#line 151 "../src/chess-engine.vala"
	chess_engine_do_undo (self);
#line 744 "chess-engine.c"
}

void
chess_engine_stop (ChessEngine* self,
                   gboolean kill_engine)
{
	GIOChannel* _tmp0_;
	gboolean _tmp6_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 154 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/chess-engine.vala"
	_tmp0_ = self->priv->stdout_channel;
#line 154 "../src/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (_tmp0_ != NULL), "!started || stdout_channel != null");
#line 154 "../src/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (self->priv->stdin_fd != -1), "!started || stdin_fd != -1");
#line 154 "../src/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (self->priv->stderr_fd != -1), "!started || stderr_fd != -1");
#line 154 "../src/chess-engine.vala"
	_vala_return_if_fail ((!self->priv->started) || (self->priv->pid != ((GPid) 0)), "!started || pid != 0");
#line 160 "../src/chess-engine.vala"
	if (!self->priv->started) {
#line 161 "../src/chess-engine.vala"
		return;
#line 770 "chess-engine.c"
	}
#line 162 "../src/chess-engine.vala"
	self->priv->started = FALSE;
#line 165 "../src/chess-engine.vala"
	if (self->priv->stdout_watch_id != ((guint) 0)) {
#line 166 "../src/chess-engine.vala"
		g_source_remove (self->priv->stdout_watch_id);
#line 167 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 780 "chess-engine.c"
	}
	{
		GIOChannel* _tmp1_;
#line 172 "../src/chess-engine.vala"
		_tmp1_ = self->priv->stdout_channel;
#line 172 "../src/chess-engine.vala"
		g_io_channel_shutdown (_tmp1_, FALSE, &_inner_error0_);
#line 172 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 792 "chess-engine.c"
				goto __catch4_g_io_channel_error;
			}
#line 172 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 172 "../src/chess-engine.vala"
			return;
#line 801 "chess-engine.c"
		}
	}
	goto __finally4;
	__catch4_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 170 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 170 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 176 "../src/chess-engine.vala"
		_tmp2_ = e;
#line 176 "../src/chess-engine.vala"
		_tmp3_ = _tmp2_->message;
#line 176 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:176: Failed to close channel to engine's stdout: %s", _tmp3_);
#line 170 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 822 "chess-engine.c"
	}
	__finally4:
#line 170 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 170 "../src/chess-engine.vala"
		return;
#line 833 "chess-engine.c"
	}
#line 178 "../src/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 178 "../src/chess-engine.vala"
	self->priv->stdout_channel = NULL;
#line 180 "../src/chess-engine.vala"
	if (close (self->priv->stdin_fd) == -1) {
#line 841 "chess-engine.c"
		const gchar* _tmp4_;
#line 181 "../src/chess-engine.vala"
		_tmp4_ = g_strerror (errno);
#line 181 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:181: Failed to close pipe to engine's stdin: %s", _tmp4_);
#line 847 "chess-engine.c"
	}
#line 182 "../src/chess-engine.vala"
	self->priv->stdin_fd = -1;
#line 184 "../src/chess-engine.vala"
	if (close (self->priv->stderr_fd) == -1) {
#line 853 "chess-engine.c"
		const gchar* _tmp5_;
#line 185 "../src/chess-engine.vala"
		_tmp5_ = g_strerror (errno);
#line 185 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:185: Failed to close pipe to engine's stderr: %s", _tmp5_);
#line 859 "chess-engine.c"
	}
#line 186 "../src/chess-engine.vala"
	self->priv->stderr_fd = -1;
#line 188 "../src/chess-engine.vala"
	if (kill_engine) {
#line 188 "../src/chess-engine.vala"
		_tmp6_ = kill ((pid_t) self->priv->pid, (gint) SIGTERM) == -1;
#line 867 "chess-engine.c"
	} else {
#line 188 "../src/chess-engine.vala"
		_tmp6_ = FALSE;
#line 871 "chess-engine.c"
	}
#line 188 "../src/chess-engine.vala"
	if (_tmp6_) {
#line 875 "chess-engine.c"
		const gchar* _tmp7_;
#line 189 "../src/chess-engine.vala"
		_tmp7_ = g_strerror (errno);
#line 189 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:189: Failed to kill engine: %s", _tmp7_);
#line 881 "chess-engine.c"
	}
#line 190 "../src/chess-engine.vala"
	self->priv->pid = (GPid) 0;
#line 885 "chess-engine.c"
}

static gboolean
chess_engine_read_cb (ChessEngine* self,
                      GIOChannel* source,
                      GIOCondition condition)
{
	gboolean result = FALSE;
	gchar* buf = NULL;
	gint buf_length1 = 0;
	gint _buf_size_ = 0;
	gsize n_read = 0UL;
	GIOStatus status = 0;
	gchar* _tmp0_;
	GIOStatus _tmp11_;
	GIOStatus _tmp12_;
	GError* _inner_error0_ = NULL;
#line 193 "../src/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 193 "../src/chess-engine.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 193 "../src/chess-engine.vala"
	_vala_return_val_if_fail (self->priv->stdout_watch_id != ((guint) 0), "stdout_watch_id != 0", FALSE);
#line 200 "../src/chess-engine.vala"
	_tmp0_ = g_new0 (gchar, 1024);
#line 200 "../src/chess-engine.vala"
	buf = (g_free (buf), NULL);
#line 200 "../src/chess-engine.vala"
	buf = _tmp0_;
#line 200 "../src/chess-engine.vala"
	buf_length1 = 1024;
#line 200 "../src/chess-engine.vala"
	_buf_size_ = buf_length1;
#line 919 "chess-engine.c"
	{
		GIOStatus _tmp1_ = 0;
		gchar* _tmp2_;
		gint _tmp2__length1;
		gsize _tmp3_ = 0UL;
		GIOStatus _tmp4_;
#line 203 "../src/chess-engine.vala"
		_tmp2_ = buf;
#line 203 "../src/chess-engine.vala"
		_tmp2__length1 = buf_length1;
#line 203 "../src/chess-engine.vala"
		_tmp4_ = g_io_channel_read_chars (source, _tmp2_, (gint) _tmp2__length1, &_tmp3_, &_inner_error0_);
#line 203 "../src/chess-engine.vala"
		n_read = _tmp3_;
#line 203 "../src/chess-engine.vala"
		_tmp1_ = _tmp4_;
#line 203 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 938 "chess-engine.c"
			gboolean _tmp5_ = FALSE;
#line 203 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 942 "chess-engine.c"
				goto __catch5_g_convert_error;
			}
#line 203 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 947 "chess-engine.c"
				goto __catch5_g_io_channel_error;
			}
#line 203 "../src/chess-engine.vala"
			buf = (g_free (buf), NULL);
#line 203 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 203 "../src/chess-engine.vala"
			return _tmp5_;
#line 958 "chess-engine.c"
		}
#line 203 "../src/chess-engine.vala"
		status = _tmp1_;
#line 962 "chess-engine.c"
	}
	goto __finally5;
	__catch5_g_convert_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 201 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 201 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 207 "../src/chess-engine.vala"
		_tmp6_ = e;
#line 207 "../src/chess-engine.vala"
		_tmp7_ = _tmp6_->message;
#line 207 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:207: Failed to read from engine: %s", _tmp7_);
#line 208 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 209 "../src/chess-engine.vala"
		result = FALSE;
#line 209 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 209 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 209 "../src/chess-engine.vala"
		return result;
#line 990 "chess-engine.c"
	}
	goto __finally5;
	__catch5_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 201 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 201 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 213 "../src/chess-engine.vala"
		_tmp8_ = e;
#line 213 "../src/chess-engine.vala"
		_tmp9_ = _tmp8_->message;
#line 213 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:213: Failed to read from engine: %s", _tmp9_);
#line 214 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 215 "../src/chess-engine.vala"
		result = FALSE;
#line 215 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 215 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 215 "../src/chess-engine.vala"
		return result;
#line 1018 "chess-engine.c"
	}
	__finally5:
#line 201 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1023 "chess-engine.c"
		gboolean _tmp10_ = FALSE;
#line 201 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 201 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 201 "../src/chess-engine.vala"
		return _tmp10_;
#line 1033 "chess-engine.c"
	}
#line 218 "../src/chess-engine.vala"
	_tmp11_ = status;
#line 218 "../src/chess-engine.vala"
	if (_tmp11_ == G_IO_STATUS_EOF) {
#line 220 "../src/chess-engine.vala"
		g_debug ("chess-engine.vala:220: EOF");
#line 221 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 222 "../src/chess-engine.vala"
		result = FALSE;
#line 222 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 222 "../src/chess-engine.vala"
		return result;
#line 1049 "chess-engine.c"
	}
#line 224 "../src/chess-engine.vala"
	_tmp12_ = status;
#line 224 "../src/chess-engine.vala"
	if (_tmp12_ == G_IO_STATUS_NORMAL) {
#line 1055 "chess-engine.c"
		gint _tmp13_;
		gchar* _tmp14_;
		gint _tmp14__length1;
#line 226 "../src/chess-engine.vala"
		_tmp13_ = (gint) n_read;
#line 226 "../src/chess-engine.vala"
		buf = g_renew (gchar, buf, (gint) n_read);
#line 226 "../src/chess-engine.vala"
		(_tmp13_ > buf_length1) ? memset (buf + buf_length1, 0, sizeof (gchar) * (_tmp13_ - buf_length1)) : NULL;
#line 226 "../src/chess-engine.vala"
		buf_length1 = _tmp13_;
#line 226 "../src/chess-engine.vala"
		_buf_size_ = _tmp13_;
#line 227 "../src/chess-engine.vala"
		_tmp14_ = buf;
#line 227 "../src/chess-engine.vala"
		_tmp14__length1 = buf_length1;
#line 227 "../src/chess-engine.vala"
		chess_engine_process_input (self, _tmp14_, (gint) _tmp14__length1);
#line 1075 "chess-engine.c"
	}
#line 230 "../src/chess-engine.vala"
	result = TRUE;
#line 230 "../src/chess-engine.vala"
	buf = (g_free (buf), NULL);
#line 230 "../src/chess-engine.vala"
	return result;
#line 1083 "chess-engine.c"
}

void
chess_engine_write (ChessEngine* self,
                    gchar* data,
                    gint data_length1)
{
	gsize offset = 0UL;
	gsize n_written = 0UL;
#line 233 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/chess-engine.vala"
	offset = (gsize) 0;
#line 236 "../src/chess-engine.vala"
	n_written = (gsize) 0;
#line 1099 "chess-engine.c"
	{
		gboolean _tmp0_ = FALSE;
#line 238 "../src/chess-engine.vala"
		_tmp0_ = TRUE;
#line 238 "../src/chess-engine.vala"
		while (TRUE) {
#line 238 "../src/chess-engine.vala"
			if (!_tmp0_) {
#line 1108 "chess-engine.c"
				gboolean _tmp1_ = FALSE;
#line 242 "../src/chess-engine.vala"
				if (n_written > ((gsize) 0)) {
#line 242 "../src/chess-engine.vala"
					_tmp1_ = offset < ((gsize) data_length1);
#line 1114 "chess-engine.c"
				} else {
#line 242 "../src/chess-engine.vala"
					_tmp1_ = FALSE;
#line 1118 "chess-engine.c"
				}
#line 242 "../src/chess-engine.vala"
				if (!_tmp1_) {
#line 242 "../src/chess-engine.vala"
					break;
#line 1124 "chess-engine.c"
				}
			}
#line 238 "../src/chess-engine.vala"
			_tmp0_ = FALSE;
#line 240 "../src/chess-engine.vala"
			n_written = (gsize) write (self->priv->stdin_fd, &data[offset], data_length1 - offset);
#line 241 "../src/chess-engine.vala"
			offset = offset + n_written;
#line 1133 "chess-engine.c"
		}
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gchar* result = NULL;
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp5_;
	gint _tmp5__length1;
#line 1505 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1506 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1506 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1506 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1507 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1507 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1507 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1507 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1508 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1508 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1509 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1509 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1509 "glib-2.0.vapi"
	memcpy (_tmp4_, self, (gsize) string_length);
#line 1510 "glib-2.0.vapi"
	_tmp5_ = _result_;
#line 1510 "glib-2.0.vapi"
	_tmp5__length1 = _result__length1;
#line 1510 "glib-2.0.vapi"
	if (result_length1) {
#line 1510 "glib-2.0.vapi"
		*result_length1 = _tmp5__length1;
#line 1189 "chess-engine.c"
	}
#line 1510 "glib-2.0.vapi"
	result = _tmp5_;
#line 1510 "glib-2.0.vapi"
	return result;
#line 1195 "chess-engine.c"
}

void
chess_engine_write_line (ChessEngine* self,
                         const gchar* line)
{
	gchar* l = NULL;
	gchar* _tmp0_;
	gchar* d = NULL;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	gchar* _tmp3_;
	gint d_length1;
	gint _d_size_;
	gchar* _tmp4_;
	gint _tmp4__length1;
#line 245 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/chess-engine.vala"
	g_return_if_fail (line != NULL);
#line 247 "../src/chess-engine.vala"
	_tmp0_ = g_strconcat (line, "\n", NULL);
#line 247 "../src/chess-engine.vala"
	l = _tmp0_;
#line 248 "../src/chess-engine.vala"
	g_debug ("chess-engine.vala:248: Writing line to engine: '%s'", line);
#line 249 "../src/chess-engine.vala"
	_tmp1_ = l;
#line 249 "../src/chess-engine.vala"
	_tmp3_ = string_to_utf8 (_tmp1_, &_tmp2_);
#line 249 "../src/chess-engine.vala"
	d = _tmp3_;
#line 249 "../src/chess-engine.vala"
	d_length1 = _tmp2_;
#line 249 "../src/chess-engine.vala"
	_d_size_ = d_length1;
#line 250 "../src/chess-engine.vala"
	_tmp4_ = d;
#line 250 "../src/chess-engine.vala"
	_tmp4__length1 = d_length1;
#line 250 "../src/chess-engine.vala"
	if (_tmp4_ != NULL) {
#line 1238 "chess-engine.c"
		gchar* _tmp5_;
		gint _tmp5__length1;
#line 251 "../src/chess-engine.vala"
		_tmp5_ = d;
#line 251 "../src/chess-engine.vala"
		_tmp5__length1 = d_length1;
#line 251 "../src/chess-engine.vala"
		chess_engine_write (self, _tmp5_, (gint) _tmp5__length1);
#line 1247 "chess-engine.c"
	}
#line 245 "../src/chess-engine.vala"
	d = (g_free (d), NULL);
#line 245 "../src/chess-engine.vala"
	_g_free0 (l);
#line 1253 "chess-engine.c"
}

gboolean
chess_engine_get_ready (ChessEngine* self)
{
	gboolean result;
#line 48 "../src/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/chess-engine.vala"
	result = self->priv->_ready;
#line 50 "../src/chess-engine.vala"
	return result;
#line 1266 "chess-engine.c"
}

void
chess_engine_set_ready (ChessEngine* self,
                        gboolean value)
{
#line 43 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/chess-engine.vala"
	self->priv->_ready = value;
#line 46 "../src/chess-engine.vala"
	g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_READY_CHANGED_SIGNAL], 0);
#line 43 "../src/chess-engine.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_engine_properties[CHESS_ENGINE_READY_PROPERTY]);
#line 1281 "chess-engine.c"
}

static void
chess_engine_class_init (ChessEngineClass * klass,
                         gpointer klass_data)
{
#line 14 "../src/chess-engine.vala"
	chess_engine_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/chess-engine.vala"
	g_type_class_adjust_private_offset (klass, &ChessEngine_private_offset);
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->process_input = (void (*) (ChessEngine*, gchar*, gint)) chess_engine_real_process_input;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->start_game = (void (*) (ChessEngine*)) chess_engine_real_start_game;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->report_move = (void (*) (ChessEngine*, ChessMove*)) chess_engine_real_report_move;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->do_undo = (void (*) (ChessEngine*)) chess_engine_real_do_undo;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->request_move = (void (*) (ChessEngine*)) chess_engine_real_request_move;
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_engine_get_property;
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_engine_set_property;
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_engine_finalize;
#line 14 "../src/chess-engine.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_ENGINE_READY_PROPERTY, chess_engine_properties[CHESS_ENGINE_READY_PROPERTY] = g_param_spec_boolean ("ready", "ready", "ready", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_STARTING_SIGNAL] = g_signal_new ("starting", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_READY_CHANGED_SIGNAL] = g_signal_new ("ready-changed", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_RESIGNED_SIGNAL] = g_signal_new ("resigned", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL] = g_signal_new ("stopped-unexpectedly", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_ERROR_SIGNAL] = g_signal_new ("error", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_CLAIM_DRAW_SIGNAL] = g_signal_new ("claim-draw", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_OFFER_DRAW_SIGNAL] = g_signal_new ("offer-draw", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1326 "chess-engine.c"
}

static void
chess_engine_instance_init (ChessEngine * self,
                            gpointer klass)
{
#line 14 "../src/chess-engine.vala"
	self->priv = chess_engine_get_instance_private (self);
#line 22 "../src/chess-engine.vala"
	self->priv->pid = (GPid) 0;
#line 23 "../src/chess-engine.vala"
	self->priv->stdin_fd = -1;
#line 24 "../src/chess-engine.vala"
	self->priv->stderr_fd = -1;
#line 26 "../src/chess-engine.vala"
	self->priv->stdout_watch_id = (guint) 0;
#line 27 "../src/chess-engine.vala"
	self->priv->started = FALSE;
#line 40 "../src/chess-engine.vala"
	self->priv->_ready = FALSE;
#line 1347 "chess-engine.c"
}

static void
chess_engine_finalize (GObject * obj)
{
	ChessEngine * self;
#line 14 "../src/chess-engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_ENGINE, ChessEngine);
#line 63 "../src/chess-engine.vala"
	_vala_assert (!self->priv->started, "!started");
#line 16 "../src/chess-engine.vala"
	_g_free0 (self->priv->binary);
#line 17 "../src/chess-engine.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_free), NULL);
#line 25 "../src/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (chess_engine_parent_class)->finalize (obj);
#line 1366 "chess-engine.c"
}

GType
chess_engine_get_type (void)
{
	static volatile gsize chess_engine_type_id__volatile = 0;
	if (g_once_init_enter (&chess_engine_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEngine), 0, (GInstanceInitFunc) chess_engine_instance_init, NULL };
		GType chess_engine_type_id;
		chess_engine_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessEngine", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		ChessEngine_private_offset = g_type_add_instance_private (chess_engine_type_id, sizeof (ChessEnginePrivate));
		g_once_init_leave (&chess_engine_type_id__volatile, chess_engine_type_id);
	}
	return chess_engine_type_id__volatile;
}

static void
_vala_chess_engine_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ChessEngine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_ENGINE, ChessEngine);
#line 14 "../src/chess-engine.vala"
	switch (property_id) {
#line 14 "../src/chess-engine.vala"
		case CHESS_ENGINE_READY_PROPERTY:
#line 14 "../src/chess-engine.vala"
		g_value_set_boolean (value, chess_engine_get_ready (self));
#line 14 "../src/chess-engine.vala"
		break;
#line 1399 "chess-engine.c"
		default:
#line 14 "../src/chess-engine.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-engine.vala"
		break;
#line 1405 "chess-engine.c"
	}
}

static void
_vala_chess_engine_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ChessEngine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_ENGINE, ChessEngine);
#line 14 "../src/chess-engine.vala"
	switch (property_id) {
#line 14 "../src/chess-engine.vala"
		case CHESS_ENGINE_READY_PROPERTY:
#line 14 "../src/chess-engine.vala"
		chess_engine_set_ready (self, g_value_get_boolean (value));
#line 14 "../src/chess-engine.vala"
		break;
#line 1425 "chess-engine.c"
		default:
#line 14 "../src/chess-engine.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-engine.vala"
		break;
#line 1431 "chess-engine.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

