/* chess-state.c generated by valac 0.44.0, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;

#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;
typedef struct _ChessStatePrivate ChessStatePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;

#define TYPE_COLOR (color_get_type ())
typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;

#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef struct _ChessPiecePrivate ChessPiecePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ChessMovePrivate ChessMovePrivate;
typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;

#define TYPE_CHESS_RULE (chess_rule_get_type ())
typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;

#define TYPE_CHESS_RESULT (chess_result_get_type ())

struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};

static gint ChessState_private_offset;
static gpointer chess_state_parent_class = NULL;

GType check_state_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessState, g_object_unref)
GType chess_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessPlayer, g_object_unref)
GType chess_piece_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessPiece, g_object_unref)
GType chess_move_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessMove, g_object_unref)
static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType color_get_type (void) G_GNUC_CONST;
ChessPlayer* chess_player_new (Color color);
ChessPlayer* chess_player_construct (GType object_type,
                                     Color color);
GType piece_type_get_type (void) G_GNUC_CONST;
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
ChessPiece* chess_piece_new (ChessPlayer* player,
                             PieceType type);
ChessPiece* chess_piece_construct (GType object_type,
                                   ChessPlayer* player,
                                   PieceType type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
ChessState* chess_state_copy (ChessState* self);
ChessMove* chess_move_copy (ChessMove* self);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
gchar* chess_state_get_fen (ChessState* self);
gunichar chess_piece_get_symbol (ChessPiece* self);
gint chess_state_get_file (ChessState* self,
                           gint index);
gint chess_state_get_rank (ChessState* self,
                           gint index);
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
gboolean chess_state_move_with_coords (ChessState* self,
                                       ChessPlayer* player,
                                       gint r0,
                                       gint f0,
                                       gint r1,
                                       gint f1,
                                       PieceType promotion_type,
                                       gboolean apply,
                                       gboolean test_check);
Color chess_piece_get_color (ChessPiece* self);
gboolean chess_state_is_in_check (ChessState* self,
                                  ChessPlayer* player);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_result_get_type (void) G_GNUC_CONST;
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
static gboolean chess_state_can_move (ChessState* self,
                               ChessPlayer* player);
gboolean chess_state_have_sufficient_material (ChessState* self);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
ChessPlayer* chess_state_get_opponent (ChessState* self);
static void chess_state_finalize (GObject * obj);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const gint64 BIT_BOARD_set_location_masks[64];
extern const gint64 BIT_BOARD_move_masks[768];
extern const gint64 BIT_BOARD_over_masks[4096];
extern const gint64 BIT_BOARD_clear_location_masks[64];

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__volatile = 0;
	if (g_once_init_enter (&check_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
		GType check_state_type_id;
		check_state_type_id = g_enum_register_static ("CheckState", values);
		g_once_init_leave (&check_state_type_id__volatile, check_state_type_id);
	}
	return check_state_type_id__volatile;
}

static inline gpointer
chess_state_get_instance_private (ChessState* self)
{
	return G_STRUCT_MEMBER_P (self, ChessState_private_offset);
}

static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
#line 41 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 41 "../lib/chess-state.vala"
	return self;
#line 316 "chess-state.c"
}

static ChessState*
chess_state_new_empty (void)
{
#line 41 "../lib/chess-state.vala"
	return chess_state_construct_empty (TYPE_CHESS_STATE);
#line 324 "chess-state.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 341 "chess-state.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../lib/chess-state.vala"
	return self ? g_object_ref (self) : NULL;
#line 349 "chess-state.c"
}

ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	const gchar* _tmp35_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	const gchar* _tmp43_;
	gchar** _tmp52_;
	gint _tmp52__length1;
	const gchar* _tmp53_;
	gchar** _tmp58_;
	gint _tmp58__length1;
	const gchar* _tmp59_;
	gchar** _tmp60_;
	gint _tmp60__length1;
	const gchar* _tmp61_;
	ChessPlayer* _tmp62_;
	Color _tmp63_;
	ChessPlayer* _tmp65_;
#line 46 "../lib/chess-state.vala"
	g_return_val_if_fail (fen != NULL, NULL);
#line 46 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 48 "../lib/chess-state.vala"
	_tmp0_ = chess_player_new (COLOR_WHITE);
#line 48 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_WHITE]);
#line 48 "../lib/chess-state.vala"
	self->players[COLOR_WHITE] = _tmp0_;
#line 49 "../lib/chess-state.vala"
	_tmp1_ = chess_player_new (COLOR_BLACK);
#line 49 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_BLACK]);
#line 49 "../lib/chess-state.vala"
	self->players[COLOR_BLACK] = _tmp1_;
#line 406 "chess-state.c"
	{
		gint i = 0;
#line 50 "../lib/chess-state.vala"
		i = 0;
#line 411 "chess-state.c"
		{
			gboolean _tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
			_tmp2_ = TRUE;
#line 50 "../lib/chess-state.vala"
			while (TRUE) {
#line 50 "../lib/chess-state.vala"
				if (!_tmp2_) {
#line 420 "chess-state.c"
					gint _tmp3_;
#line 50 "../lib/chess-state.vala"
					_tmp3_ = i;
#line 50 "../lib/chess-state.vala"
					i = _tmp3_ + 1;
#line 426 "chess-state.c"
				}
#line 50 "../lib/chess-state.vala"
				_tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 50 "../lib/chess-state.vala"
					break;
#line 434 "chess-state.c"
				}
#line 51 "../lib/chess-state.vala"
				_g_object_unref0 (self->board[i]);
#line 51 "../lib/chess-state.vala"
				self->board[i] = NULL;
#line 440 "chess-state.c"
			}
		}
	}
#line 53 "../lib/chess-state.vala"
	_tmp5_ = _tmp4_ = g_strsplit (fen, " ", 0);
#line 53 "../lib/chess-state.vala"
	fields = _tmp5_;
#line 53 "../lib/chess-state.vala"
	fields_length1 = _vala_array_length (_tmp4_);
#line 53 "../lib/chess-state.vala"
	_fields_size_ = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp6_ = fields;
#line 58 "../lib/chess-state.vala"
	_tmp6__length1 = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp7_ = _tmp6_[0];
#line 58 "../lib/chess-state.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "/", 0);
#line 58 "../lib/chess-state.vala"
	ranks = _tmp9_;
#line 58 "../lib/chess-state.vala"
	ranks_length1 = _vala_array_length (_tmp8_);
#line 58 "../lib/chess-state.vala"
	_ranks_size_ = ranks_length1;
#line 466 "chess-state.c"
	{
		gint rank = 0;
#line 61 "../lib/chess-state.vala"
		rank = 0;
#line 471 "chess-state.c"
		{
			gboolean _tmp10_ = FALSE;
#line 61 "../lib/chess-state.vala"
			_tmp10_ = TRUE;
#line 61 "../lib/chess-state.vala"
			while (TRUE) {
#line 478 "chess-state.c"
				gchar* rank_string = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 61 "../lib/chess-state.vala"
				if (!_tmp10_) {
#line 486 "chess-state.c"
					gint _tmp11_;
#line 61 "../lib/chess-state.vala"
					_tmp11_ = rank;
#line 61 "../lib/chess-state.vala"
					rank = _tmp11_ + 1;
#line 492 "chess-state.c"
				}
#line 61 "../lib/chess-state.vala"
				_tmp10_ = FALSE;
#line 61 "../lib/chess-state.vala"
				if (!(rank < 8)) {
#line 61 "../lib/chess-state.vala"
					break;
#line 500 "chess-state.c"
				}
#line 63 "../lib/chess-state.vala"
				_tmp12_ = ranks;
#line 63 "../lib/chess-state.vala"
				_tmp12__length1 = ranks_length1;
#line 63 "../lib/chess-state.vala"
				_tmp13_ = _tmp12_[7 - rank];
#line 63 "../lib/chess-state.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 63 "../lib/chess-state.vala"
				rank_string = _tmp14_;
#line 512 "chess-state.c"
				{
					gint file = 0;
					gint offset = 0;
#line 64 "../lib/chess-state.vala"
					file = 0;
#line 64 "../lib/chess-state.vala"
					offset = 0;
#line 520 "chess-state.c"
					{
						gboolean _tmp15_ = FALSE;
#line 64 "../lib/chess-state.vala"
						_tmp15_ = TRUE;
#line 64 "../lib/chess-state.vala"
						while (TRUE) {
#line 527 "chess-state.c"
							gboolean _tmp17_ = FALSE;
							gchar c = '\0';
							const gchar* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PieceType type = 0;
							Color _tmp23_ = 0;
							Color color = 0;
							PieceType _tmp24_ = 0;
							gint index = 0;
							ChessPiece* piece = NULL;
							Color _tmp25_;
							ChessPlayer* _tmp26_;
							PieceType _tmp27_;
							ChessPiece* _tmp28_;
							ChessPiece* _tmp29_;
							ChessPiece* _tmp30_;
							gint64 mask = 0LL;
							gint64 _tmp31_;
							Color _tmp32_;
							gint _tmp33_;
#line 64 "../lib/chess-state.vala"
							if (!_tmp15_) {
#line 550 "chess-state.c"
								gint _tmp16_;
#line 64 "../lib/chess-state.vala"
								_tmp16_ = offset;
#line 64 "../lib/chess-state.vala"
								offset = _tmp16_ + 1;
#line 556 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							_tmp15_ = FALSE;
#line 64 "../lib/chess-state.vala"
							if (file < 8) {
#line 562 "chess-state.c"
								const gchar* _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
#line 64 "../lib/chess-state.vala"
								_tmp18_ = rank_string;
#line 64 "../lib/chess-state.vala"
								_tmp19_ = strlen (_tmp18_);
#line 64 "../lib/chess-state.vala"
								_tmp20_ = _tmp19_;
#line 64 "../lib/chess-state.vala"
								_tmp17_ = offset < _tmp20_;
#line 574 "chess-state.c"
							} else {
#line 64 "../lib/chess-state.vala"
								_tmp17_ = FALSE;
#line 578 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							if (!_tmp17_) {
#line 64 "../lib/chess-state.vala"
								break;
#line 584 "chess-state.c"
							}
#line 66 "../lib/chess-state.vala"
							_tmp21_ = rank_string;
#line 66 "../lib/chess-state.vala"
							c = string_get (_tmp21_, (glong) offset);
#line 67 "../lib/chess-state.vala"
							if (c >= '1') {
#line 67 "../lib/chess-state.vala"
								_tmp22_ = c <= '8';
#line 594 "chess-state.c"
							} else {
#line 67 "../lib/chess-state.vala"
								_tmp22_ = FALSE;
#line 598 "chess-state.c"
							}
#line 67 "../lib/chess-state.vala"
							if (_tmp22_) {
#line 69 "../lib/chess-state.vala"
								file = file + (c - '0');
#line 70 "../lib/chess-state.vala"
								continue;
#line 606 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							if (g_ascii_isupper (c)) {
#line 74 "../lib/chess-state.vala"
								_tmp23_ = COLOR_WHITE;
#line 612 "chess-state.c"
							} else {
#line 74 "../lib/chess-state.vala"
								_tmp23_ = COLOR_BLACK;
#line 616 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							color = _tmp23_;
#line 75 "../lib/chess-state.vala"
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (c), &_tmp24_);
#line 75 "../lib/chess-state.vala"
							type = _tmp24_;
#line 78 "../lib/chess-state.vala"
							index = chess_state_get_index (self, rank, file);
#line 79 "../lib/chess-state.vala"
							_tmp25_ = color;
#line 79 "../lib/chess-state.vala"
							_tmp26_ = self->players[_tmp25_];
#line 79 "../lib/chess-state.vala"
							_tmp27_ = type;
#line 79 "../lib/chess-state.vala"
							_tmp28_ = chess_piece_new (_tmp26_, _tmp27_);
#line 79 "../lib/chess-state.vala"
							piece = _tmp28_;
#line 80 "../lib/chess-state.vala"
							_tmp29_ = piece;
#line 80 "../lib/chess-state.vala"
							_tmp30_ = _g_object_ref0 (_tmp29_);
#line 80 "../lib/chess-state.vala"
							_g_object_unref0 (self->board[index]);
#line 80 "../lib/chess-state.vala"
							self->board[index] = _tmp30_;
#line 81 "../lib/chess-state.vala"
							_tmp31_ = BIT_BOARD_set_location_masks[index];
#line 81 "../lib/chess-state.vala"
							mask = _tmp31_;
#line 82 "../lib/chess-state.vala"
							_tmp32_ = color;
#line 82 "../lib/chess-state.vala"
							self->priv->piece_masks[_tmp32_] |= mask;
#line 83 "../lib/chess-state.vala"
							_tmp33_ = file;
#line 83 "../lib/chess-state.vala"
							file = _tmp33_ + 1;
#line 64 "../lib/chess-state.vala"
							_g_object_unref0 (piece);
#line 658 "chess-state.c"
						}
					}
				}
#line 61 "../lib/chess-state.vala"
				_g_free0 (rank_string);
#line 664 "chess-state.c"
			}
		}
	}
#line 88 "../lib/chess-state.vala"
	_tmp34_ = fields;
#line 88 "../lib/chess-state.vala"
	_tmp34__length1 = fields_length1;
#line 88 "../lib/chess-state.vala"
	_tmp35_ = _tmp34_[1];
#line 88 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp35_, "w") == 0) {
#line 676 "chess-state.c"
		ChessPlayer* _tmp36_;
		ChessPlayer* _tmp37_;
#line 89 "../lib/chess-state.vala"
		_tmp36_ = self->players[COLOR_WHITE];
#line 89 "../lib/chess-state.vala"
		_tmp37_ = _g_object_ref0 (_tmp36_);
#line 89 "../lib/chess-state.vala"
		_g_object_unref0 (self->current_player);
#line 89 "../lib/chess-state.vala"
		self->current_player = _tmp37_;
#line 687 "chess-state.c"
	} else {
		gchar** _tmp38_;
		gint _tmp38__length1;
		const gchar* _tmp39_;
#line 90 "../lib/chess-state.vala"
		_tmp38_ = fields;
#line 90 "../lib/chess-state.vala"
		_tmp38__length1 = fields_length1;
#line 90 "../lib/chess-state.vala"
		_tmp39_ = _tmp38_[1];
#line 90 "../lib/chess-state.vala"
		if (g_strcmp0 (_tmp39_, "b") == 0) {
#line 700 "chess-state.c"
			ChessPlayer* _tmp40_;
			ChessPlayer* _tmp41_;
#line 91 "../lib/chess-state.vala"
			_tmp40_ = self->players[COLOR_BLACK];
#line 91 "../lib/chess-state.vala"
			_tmp41_ = _g_object_ref0 (_tmp40_);
#line 91 "../lib/chess-state.vala"
			_g_object_unref0 (self->current_player);
#line 91 "../lib/chess-state.vala"
			self->current_player = _tmp41_;
#line 711 "chess-state.c"
		}
	}
#line 96 "../lib/chess-state.vala"
	_tmp42_ = fields;
#line 96 "../lib/chess-state.vala"
	_tmp42__length1 = fields_length1;
#line 96 "../lib/chess-state.vala"
	_tmp43_ = _tmp42_[2];
#line 96 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp43_, "-") != 0) {
#line 722 "chess-state.c"
		{
			gint i = 0;
#line 98 "../lib/chess-state.vala"
			i = 0;
#line 727 "chess-state.c"
			{
				gboolean _tmp44_ = FALSE;
#line 98 "../lib/chess-state.vala"
				_tmp44_ = TRUE;
#line 98 "../lib/chess-state.vala"
				while (TRUE) {
#line 734 "chess-state.c"
					gchar** _tmp46_;
					gint _tmp46__length1;
					const gchar* _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					gchar c = '\0';
					gchar** _tmp50_;
					gint _tmp50__length1;
					const gchar* _tmp51_;
#line 98 "../lib/chess-state.vala"
					if (!_tmp44_) {
#line 746 "chess-state.c"
						gint _tmp45_;
#line 98 "../lib/chess-state.vala"
						_tmp45_ = i;
#line 98 "../lib/chess-state.vala"
						i = _tmp45_ + 1;
#line 752 "chess-state.c"
					}
#line 98 "../lib/chess-state.vala"
					_tmp44_ = FALSE;
#line 98 "../lib/chess-state.vala"
					_tmp46_ = fields;
#line 98 "../lib/chess-state.vala"
					_tmp46__length1 = fields_length1;
#line 98 "../lib/chess-state.vala"
					_tmp47_ = _tmp46_[2];
#line 98 "../lib/chess-state.vala"
					_tmp48_ = strlen (_tmp47_);
#line 98 "../lib/chess-state.vala"
					_tmp49_ = _tmp48_;
#line 98 "../lib/chess-state.vala"
					if (!(i < _tmp49_)) {
#line 98 "../lib/chess-state.vala"
						break;
#line 770 "chess-state.c"
					}
#line 100 "../lib/chess-state.vala"
					_tmp50_ = fields;
#line 100 "../lib/chess-state.vala"
					_tmp50__length1 = fields_length1;
#line 100 "../lib/chess-state.vala"
					_tmp51_ = _tmp50_[2];
#line 100 "../lib/chess-state.vala"
					c = string_get (_tmp51_, (glong) i);
#line 101 "../lib/chess-state.vala"
					if (c == 'K') {
#line 102 "../lib/chess-state.vala"
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
#line 784 "chess-state.c"
					} else {
#line 103 "../lib/chess-state.vala"
						if (c == 'Q') {
#line 104 "../lib/chess-state.vala"
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
#line 790 "chess-state.c"
						} else {
#line 105 "../lib/chess-state.vala"
							if (c == 'k') {
#line 106 "../lib/chess-state.vala"
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
#line 796 "chess-state.c"
							} else {
#line 107 "../lib/chess-state.vala"
								if (c == 'q') {
#line 108 "../lib/chess-state.vala"
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
#line 802 "chess-state.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 115 "../lib/chess-state.vala"
	_tmp52_ = fields;
#line 115 "../lib/chess-state.vala"
	_tmp52__length1 = fields_length1;
#line 115 "../lib/chess-state.vala"
	_tmp53_ = _tmp52_[3];
#line 115 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp53_, "-") != 0) {
#line 819 "chess-state.c"
		gchar** _tmp54_;
		gint _tmp54__length1;
		const gchar* _tmp55_;
		gchar** _tmp56_;
		gint _tmp56__length1;
		const gchar* _tmp57_;
#line 119 "../lib/chess-state.vala"
		_tmp54_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp54__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp55_ = _tmp54_[3];
#line 119 "../lib/chess-state.vala"
		_tmp56_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp56__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp57_ = _tmp56_[3];
#line 119 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp55_, (glong) 1) - '1'), (gint) (string_get (_tmp57_, (glong) 0) - 'a'));
#line 840 "chess-state.c"
	}
#line 123 "../lib/chess-state.vala"
	_tmp58_ = fields;
#line 123 "../lib/chess-state.vala"
	_tmp58__length1 = fields_length1;
#line 123 "../lib/chess-state.vala"
	_tmp59_ = _tmp58_[4];
#line 123 "../lib/chess-state.vala"
	self->halfmove_clock = atoi (_tmp59_);
#line 126 "../lib/chess-state.vala"
	_tmp60_ = fields;
#line 126 "../lib/chess-state.vala"
	_tmp60__length1 = fields_length1;
#line 126 "../lib/chess-state.vala"
	_tmp61_ = _tmp60_[5];
#line 126 "../lib/chess-state.vala"
	self->number = (atoi (_tmp61_) - 1) * 2;
#line 127 "../lib/chess-state.vala"
	_tmp62_ = self->current_player;
#line 127 "../lib/chess-state.vala"
	_tmp63_ = _tmp62_->color;
#line 127 "../lib/chess-state.vala"
	if (_tmp63_ == COLOR_BLACK) {
#line 864 "chess-state.c"
		gint _tmp64_;
#line 128 "../lib/chess-state.vala"
		_tmp64_ = self->number;
#line 128 "../lib/chess-state.vala"
		self->number = _tmp64_ + 1;
#line 870 "chess-state.c"
	}
#line 130 "../lib/chess-state.vala"
	_tmp65_ = self->current_player;
#line 130 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp65_);
#line 46 "../lib/chess-state.vala"
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	return self;
#line 882 "chess-state.c"
}

ChessState*
chess_state_new (const gchar* fen)
{
#line 46 "../lib/chess-state.vala"
	return chess_state_construct (TYPE_CHESS_STATE, fen);
#line 890 "chess-state.c"
}

ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* result = NULL;
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessState* _tmp2_;
	ChessPlayer* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessState* _tmp5_;
	ChessPlayer* _tmp6_;
	ChessPlayer* _tmp7_;
	ChessState* _tmp8_;
	ChessPlayer* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessState* _tmp11_;
	gboolean _tmp12_;
	ChessState* _tmp13_;
	gboolean _tmp14_;
	ChessState* _tmp15_;
	gboolean _tmp16_;
	ChessState* _tmp17_;
	gboolean _tmp18_;
	ChessState* _tmp19_;
	ChessState* _tmp20_;
	CheckState _tmp21_;
	ChessMove* _tmp22_;
	ChessState* _tmp31_;
	gint64 _tmp32_;
	ChessState* _tmp33_;
	gint64 _tmp34_;
	ChessState* _tmp35_;
#line 133 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../lib/chess-state.vala"
	_tmp0_ = chess_state_new_empty ();
#line 135 "../lib/chess-state.vala"
	state = _tmp0_;
#line 137 "../lib/chess-state.vala"
	_tmp1_ = state;
#line 137 "../lib/chess-state.vala"
	_tmp1_->number = self->number;
#line 138 "../lib/chess-state.vala"
	_tmp2_ = state;
#line 138 "../lib/chess-state.vala"
	_tmp3_ = self->players[COLOR_WHITE];
#line 138 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 138 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp2_->players[COLOR_WHITE]);
#line 138 "../lib/chess-state.vala"
	_tmp2_->players[COLOR_WHITE] = _tmp4_;
#line 139 "../lib/chess-state.vala"
	_tmp5_ = state;
#line 139 "../lib/chess-state.vala"
	_tmp6_ = self->players[COLOR_BLACK];
#line 139 "../lib/chess-state.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 139 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp5_->players[COLOR_BLACK]);
#line 139 "../lib/chess-state.vala"
	_tmp5_->players[COLOR_BLACK] = _tmp7_;
#line 140 "../lib/chess-state.vala"
	_tmp8_ = state;
#line 140 "../lib/chess-state.vala"
	_tmp9_ = self->current_player;
#line 140 "../lib/chess-state.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 140 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp8_->current_player);
#line 140 "../lib/chess-state.vala"
	_tmp8_->current_player = _tmp10_;
#line 141 "../lib/chess-state.vala"
	_tmp11_ = state;
#line 141 "../lib/chess-state.vala"
	_tmp12_ = self->can_castle_kingside[COLOR_WHITE];
#line 141 "../lib/chess-state.vala"
	_tmp11_->can_castle_kingside[COLOR_WHITE] = _tmp12_;
#line 142 "../lib/chess-state.vala"
	_tmp13_ = state;
#line 142 "../lib/chess-state.vala"
	_tmp14_ = self->can_castle_queenside[COLOR_WHITE];
#line 142 "../lib/chess-state.vala"
	_tmp13_->can_castle_queenside[COLOR_WHITE] = _tmp14_;
#line 143 "../lib/chess-state.vala"
	_tmp15_ = state;
#line 143 "../lib/chess-state.vala"
	_tmp16_ = self->can_castle_kingside[COLOR_BLACK];
#line 143 "../lib/chess-state.vala"
	_tmp15_->can_castle_kingside[COLOR_BLACK] = _tmp16_;
#line 144 "../lib/chess-state.vala"
	_tmp17_ = state;
#line 144 "../lib/chess-state.vala"
	_tmp18_ = self->can_castle_queenside[COLOR_BLACK];
#line 144 "../lib/chess-state.vala"
	_tmp17_->can_castle_queenside[COLOR_BLACK] = _tmp18_;
#line 145 "../lib/chess-state.vala"
	_tmp19_ = state;
#line 145 "../lib/chess-state.vala"
	_tmp19_->en_passant_index = self->en_passant_index;
#line 146 "../lib/chess-state.vala"
	_tmp20_ = state;
#line 146 "../lib/chess-state.vala"
	_tmp21_ = self->check_state;
#line 146 "../lib/chess-state.vala"
	_tmp20_->check_state = _tmp21_;
#line 147 "../lib/chess-state.vala"
	_tmp22_ = self->last_move;
#line 147 "../lib/chess-state.vala"
	if (_tmp22_ != NULL) {
#line 1004 "chess-state.c"
		ChessState* _tmp23_;
		ChessMove* _tmp24_;
		ChessMove* _tmp25_;
#line 148 "../lib/chess-state.vala"
		_tmp23_ = state;
#line 148 "../lib/chess-state.vala"
		_tmp24_ = self->last_move;
#line 148 "../lib/chess-state.vala"
		_tmp25_ = chess_move_copy (_tmp24_);
#line 148 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp23_->last_move);
#line 148 "../lib/chess-state.vala"
		_tmp23_->last_move = _tmp25_;
#line 1018 "chess-state.c"
	}
	{
		gint i = 0;
#line 149 "../lib/chess-state.vala"
		i = 0;
#line 1024 "chess-state.c"
		{
			gboolean _tmp26_ = FALSE;
#line 149 "../lib/chess-state.vala"
			_tmp26_ = TRUE;
#line 149 "../lib/chess-state.vala"
			while (TRUE) {
#line 1031 "chess-state.c"
				ChessState* _tmp28_;
				ChessPiece* _tmp29_;
				ChessPiece* _tmp30_;
#line 149 "../lib/chess-state.vala"
				if (!_tmp26_) {
#line 1037 "chess-state.c"
					gint _tmp27_;
#line 149 "../lib/chess-state.vala"
					_tmp27_ = i;
#line 149 "../lib/chess-state.vala"
					i = _tmp27_ + 1;
#line 1043 "chess-state.c"
				}
#line 149 "../lib/chess-state.vala"
				_tmp26_ = FALSE;
#line 149 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 149 "../lib/chess-state.vala"
					break;
#line 1051 "chess-state.c"
				}
#line 150 "../lib/chess-state.vala"
				_tmp28_ = state;
#line 150 "../lib/chess-state.vala"
				_tmp29_ = self->board[i];
#line 150 "../lib/chess-state.vala"
				_tmp30_ = _g_object_ref0 (_tmp29_);
#line 150 "../lib/chess-state.vala"
				_g_object_unref0 (_tmp28_->board[i]);
#line 150 "../lib/chess-state.vala"
				_tmp28_->board[i] = _tmp30_;
#line 1063 "chess-state.c"
			}
		}
	}
#line 151 "../lib/chess-state.vala"
	_tmp31_ = state;
#line 151 "../lib/chess-state.vala"
	_tmp32_ = self->priv->piece_masks[COLOR_WHITE];
#line 151 "../lib/chess-state.vala"
	_tmp31_->priv->piece_masks[COLOR_WHITE] = _tmp32_;
#line 152 "../lib/chess-state.vala"
	_tmp33_ = state;
#line 152 "../lib/chess-state.vala"
	_tmp34_ = self->priv->piece_masks[COLOR_BLACK];
#line 152 "../lib/chess-state.vala"
	_tmp33_->priv->piece_masks[COLOR_BLACK] = _tmp34_;
#line 153 "../lib/chess-state.vala"
	_tmp35_ = state;
#line 153 "../lib/chess-state.vala"
	_tmp35_->halfmove_clock = self->halfmove_clock;
#line 155 "../lib/chess-state.vala"
	result = state;
#line 155 "../lib/chess-state.vala"
	return result;
#line 1087 "chess-state.c"
}

gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 168 "../lib/chess-state.vala"
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	if (_tmp7_ != _tmp8_) {
#line 168 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 1116 "chess-state.c"
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
#line 169 "../lib/chess-state.vala"
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != _tmp10_;
#line 1126 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 168 "../lib/chess-state.vala"
		_tmp5_ = TRUE;
#line 1132 "chess-state.c"
	} else {
		ChessPlayer* _tmp11_;
		Color _tmp12_;
		ChessPlayer* _tmp13_;
		Color _tmp14_;
#line 170 "../lib/chess-state.vala"
		_tmp11_ = self->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp12_ = _tmp11_->color;
#line 170 "../lib/chess-state.vala"
		_tmp13_ = state->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp14_ = _tmp13_->color;
#line 170 "../lib/chess-state.vala"
		_tmp5_ = _tmp12_ != _tmp14_;
#line 1148 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 168 "../lib/chess-state.vala"
		_tmp4_ = TRUE;
#line 1154 "chess-state.c"
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 171 "../lib/chess-state.vala"
		_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp16_ = state->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp4_ = _tmp15_ != _tmp16_;
#line 1164 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 168 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 1170 "chess-state.c"
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 172 "../lib/chess-state.vala"
		_tmp17_ = self->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp18_ = state->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp3_ = _tmp17_ != _tmp18_;
#line 1180 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 168 "../lib/chess-state.vala"
		_tmp2_ = TRUE;
#line 1186 "chess-state.c"
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 173 "../lib/chess-state.vala"
		_tmp19_ = self->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp20_ = state->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp2_ = _tmp19_ != _tmp20_;
#line 1196 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 168 "../lib/chess-state.vala"
		_tmp1_ = TRUE;
#line 1202 "chess-state.c"
	} else {
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 174 "../lib/chess-state.vala"
		_tmp21_ = self->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp22_ = state->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp1_ = _tmp21_ != _tmp22_;
#line 1212 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp1_) {
#line 168 "../lib/chess-state.vala"
		_tmp0_ = TRUE;
#line 1218 "chess-state.c"
	} else {
#line 175 "../lib/chess-state.vala"
		_tmp0_ = self->en_passant_index != state->en_passant_index;
#line 1222 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp0_) {
#line 176 "../lib/chess-state.vala"
		result = FALSE;
#line 176 "../lib/chess-state.vala"
		return result;
#line 1230 "chess-state.c"
	}
	{
		gint i = 0;
#line 179 "../lib/chess-state.vala"
		i = 0;
#line 1236 "chess-state.c"
		{
			gboolean _tmp23_ = FALSE;
#line 179 "../lib/chess-state.vala"
			_tmp23_ = TRUE;
#line 179 "../lib/chess-state.vala"
			while (TRUE) {
#line 1243 "chess-state.c"
				gboolean _tmp25_ = FALSE;
				ChessPiece* _tmp26_;
#line 179 "../lib/chess-state.vala"
				if (!_tmp23_) {
#line 1248 "chess-state.c"
					gint _tmp24_;
#line 179 "../lib/chess-state.vala"
					_tmp24_ = i;
#line 179 "../lib/chess-state.vala"
					i = _tmp24_ + 1;
#line 1254 "chess-state.c"
				}
#line 179 "../lib/chess-state.vala"
				_tmp23_ = FALSE;
#line 179 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 179 "../lib/chess-state.vala"
					break;
#line 1262 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				_tmp26_ = self->board[i];
#line 181 "../lib/chess-state.vala"
				if (_tmp26_ != NULL) {
#line 1268 "chess-state.c"
					ChessPiece* _tmp27_;
					PieceType _tmp28_;
					ChessPiece* _tmp29_;
					PieceType _tmp30_;
#line 181 "../lib/chess-state.vala"
					_tmp27_ = self->board[i];
#line 181 "../lib/chess-state.vala"
					_tmp28_ = _tmp27_->type;
#line 181 "../lib/chess-state.vala"
					_tmp29_ = state->board[i];
#line 181 "../lib/chess-state.vala"
					_tmp30_ = _tmp29_->type;
#line 181 "../lib/chess-state.vala"
					_tmp25_ = _tmp28_ != _tmp30_;
#line 1283 "chess-state.c"
				} else {
#line 181 "../lib/chess-state.vala"
					_tmp25_ = FALSE;
#line 1287 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				if (_tmp25_) {
#line 182 "../lib/chess-state.vala"
					result = FALSE;
#line 182 "../lib/chess-state.vala"
					return result;
#line 1295 "chess-state.c"
				}
			}
		}
	}
#line 185 "../lib/chess-state.vala"
	result = TRUE;
#line 185 "../lib/chess-state.vala"
	return result;
#line 1304 "chess-state.c"
}

gchar*
chess_state_get_fen (ChessState* self)
{
	gchar* result = NULL;
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp16_;
	ChessPlayer* _tmp17_;
	Color _tmp18_;
	GString* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp24_;
	gboolean _tmp26_;
	gboolean _tmp28_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	GString* _tmp35_;
	GString* _tmp38_;
	GString* _tmp39_;
	GString* _tmp40_;
	ChessPlayer* _tmp41_;
	Color _tmp42_;
	GString* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
#line 188 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../lib/chess-state.vala"
	_tmp0_ = g_string_new ("");
#line 190 "../lib/chess-state.vala"
	value = _tmp0_;
#line 1340 "chess-state.c"
	{
		gint rank = 0;
#line 192 "../lib/chess-state.vala"
		rank = 7;
#line 1345 "chess-state.c"
		{
			gboolean _tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
			_tmp1_ = TRUE;
#line 192 "../lib/chess-state.vala"
			while (TRUE) {
#line 1352 "chess-state.c"
				gint skip_count = 0;
#line 192 "../lib/chess-state.vala"
				if (!_tmp1_) {
#line 1356 "chess-state.c"
					gint _tmp2_;
#line 192 "../lib/chess-state.vala"
					_tmp2_ = rank;
#line 192 "../lib/chess-state.vala"
					rank = _tmp2_ - 1;
#line 1362 "chess-state.c"
				}
#line 192 "../lib/chess-state.vala"
				_tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
				if (!(rank >= 0)) {
#line 192 "../lib/chess-state.vala"
					break;
#line 1370 "chess-state.c"
				}
#line 194 "../lib/chess-state.vala"
				skip_count = 0;
#line 1374 "chess-state.c"
				{
					gint file = 0;
#line 195 "../lib/chess-state.vala"
					file = 0;
#line 1379 "chess-state.c"
					{
						gboolean _tmp3_ = FALSE;
#line 195 "../lib/chess-state.vala"
						_tmp3_ = TRUE;
#line 195 "../lib/chess-state.vala"
						while (TRUE) {
#line 1386 "chess-state.c"
							ChessPiece* p = NULL;
							ChessPiece* _tmp5_;
							ChessPiece* _tmp6_;
							ChessPiece* _tmp7_;
#line 195 "../lib/chess-state.vala"
							if (!_tmp3_) {
#line 1393 "chess-state.c"
								gint _tmp4_;
#line 195 "../lib/chess-state.vala"
								_tmp4_ = file;
#line 195 "../lib/chess-state.vala"
								file = _tmp4_ + 1;
#line 1399 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_tmp3_ = FALSE;
#line 195 "../lib/chess-state.vala"
							if (!(file < 8)) {
#line 195 "../lib/chess-state.vala"
								break;
#line 1407 "chess-state.c"
							}
#line 197 "../lib/chess-state.vala"
							_tmp5_ = self->board[chess_state_get_index (self, rank, file)];
#line 197 "../lib/chess-state.vala"
							_tmp6_ = _g_object_ref0 (_tmp5_);
#line 197 "../lib/chess-state.vala"
							p = _tmp6_;
#line 198 "../lib/chess-state.vala"
							_tmp7_ = p;
#line 198 "../lib/chess-state.vala"
							if (_tmp7_ == NULL) {
#line 1419 "chess-state.c"
								gint _tmp8_;
#line 199 "../lib/chess-state.vala"
								_tmp8_ = skip_count;
#line 199 "../lib/chess-state.vala"
								skip_count = _tmp8_ + 1;
#line 1425 "chess-state.c"
							} else {
								GString* _tmp10_;
								ChessPiece* _tmp11_;
								gunichar _tmp12_;
								gunichar _tmp13_;
#line 202 "../lib/chess-state.vala"
								if (skip_count > 0) {
#line 1433 "chess-state.c"
									GString* _tmp9_;
#line 204 "../lib/chess-state.vala"
									_tmp9_ = value;
#line 204 "../lib/chess-state.vala"
									g_string_append_printf (_tmp9_, "%d", skip_count);
#line 205 "../lib/chess-state.vala"
									skip_count = 0;
#line 1441 "chess-state.c"
								}
#line 207 "../lib/chess-state.vala"
								_tmp10_ = value;
#line 207 "../lib/chess-state.vala"
								_tmp11_ = p;
#line 207 "../lib/chess-state.vala"
								_tmp12_ = chess_piece_get_symbol (_tmp11_);
#line 207 "../lib/chess-state.vala"
								_tmp13_ = _tmp12_;
#line 207 "../lib/chess-state.vala"
								g_string_append_printf (_tmp10_, "%c", (gint) _tmp13_);
#line 1453 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 1457 "chess-state.c"
						}
					}
				}
#line 210 "../lib/chess-state.vala"
				if (skip_count > 0) {
#line 1463 "chess-state.c"
					GString* _tmp14_;
#line 211 "../lib/chess-state.vala"
					_tmp14_ = value;
#line 211 "../lib/chess-state.vala"
					g_string_append_printf (_tmp14_, "%d", skip_count);
#line 1469 "chess-state.c"
				}
#line 212 "../lib/chess-state.vala"
				if (rank != 0) {
#line 1473 "chess-state.c"
					GString* _tmp15_;
#line 213 "../lib/chess-state.vala"
					_tmp15_ = value;
#line 213 "../lib/chess-state.vala"
					g_string_append_c (_tmp15_, '/');
#line 1479 "chess-state.c"
				}
			}
		}
	}
#line 216 "../lib/chess-state.vala"
	_tmp16_ = value;
#line 216 "../lib/chess-state.vala"
	g_string_append_c (_tmp16_, ' ');
#line 217 "../lib/chess-state.vala"
	_tmp17_ = self->current_player;
#line 217 "../lib/chess-state.vala"
	_tmp18_ = _tmp17_->color;
#line 217 "../lib/chess-state.vala"
	if (_tmp18_ == COLOR_WHITE) {
#line 1494 "chess-state.c"
		GString* _tmp19_;
#line 218 "../lib/chess-state.vala"
		_tmp19_ = value;
#line 218 "../lib/chess-state.vala"
		g_string_append_c (_tmp19_, 'w');
#line 1500 "chess-state.c"
	} else {
		GString* _tmp20_;
#line 220 "../lib/chess-state.vala"
		_tmp20_ = value;
#line 220 "../lib/chess-state.vala"
		g_string_append_c (_tmp20_, 'b');
#line 1507 "chess-state.c"
	}
#line 222 "../lib/chess-state.vala"
	_tmp21_ = value;
#line 222 "../lib/chess-state.vala"
	g_string_append_c (_tmp21_, ' ');
#line 223 "../lib/chess-state.vala"
	_tmp22_ = self->can_castle_kingside[COLOR_WHITE];
#line 223 "../lib/chess-state.vala"
	if (_tmp22_) {
#line 1517 "chess-state.c"
		GString* _tmp23_;
#line 224 "../lib/chess-state.vala"
		_tmp23_ = value;
#line 224 "../lib/chess-state.vala"
		g_string_append_c (_tmp23_, 'K');
#line 1523 "chess-state.c"
	}
#line 225 "../lib/chess-state.vala"
	_tmp24_ = self->can_castle_queenside[COLOR_WHITE];
#line 225 "../lib/chess-state.vala"
	if (_tmp24_) {
#line 1529 "chess-state.c"
		GString* _tmp25_;
#line 226 "../lib/chess-state.vala"
		_tmp25_ = value;
#line 226 "../lib/chess-state.vala"
		g_string_append_c (_tmp25_, 'Q');
#line 1535 "chess-state.c"
	}
#line 227 "../lib/chess-state.vala"
	_tmp26_ = self->can_castle_kingside[COLOR_BLACK];
#line 227 "../lib/chess-state.vala"
	if (_tmp26_) {
#line 1541 "chess-state.c"
		GString* _tmp27_;
#line 228 "../lib/chess-state.vala"
		_tmp27_ = value;
#line 228 "../lib/chess-state.vala"
		g_string_append_c (_tmp27_, 'k');
#line 1547 "chess-state.c"
	}
#line 229 "../lib/chess-state.vala"
	_tmp28_ = self->can_castle_queenside[COLOR_BLACK];
#line 229 "../lib/chess-state.vala"
	if (_tmp28_) {
#line 1553 "chess-state.c"
		GString* _tmp29_;
#line 230 "../lib/chess-state.vala"
		_tmp29_ = value;
#line 230 "../lib/chess-state.vala"
		g_string_append_c (_tmp29_, 'q');
#line 1559 "chess-state.c"
	}
#line 231 "../lib/chess-state.vala"
	_tmp30_ = self->can_castle_kingside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp31_ = self->can_castle_queenside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp32_ = self->can_castle_kingside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	_tmp33_ = self->can_castle_queenside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	if (!(((_tmp30_ | _tmp31_) | _tmp32_) | _tmp33_)) {
#line 1571 "chess-state.c"
		GString* _tmp34_;
#line 232 "../lib/chess-state.vala"
		_tmp34_ = value;
#line 232 "../lib/chess-state.vala"
		g_string_append_c (_tmp34_, '-');
#line 1577 "chess-state.c"
	}
#line 234 "../lib/chess-state.vala"
	_tmp35_ = value;
#line 234 "../lib/chess-state.vala"
	g_string_append_c (_tmp35_, ' ');
#line 235 "../lib/chess-state.vala"
	if (self->en_passant_index >= 0) {
#line 1585 "chess-state.c"
		GString* _tmp36_;
#line 236 "../lib/chess-state.vala"
		_tmp36_ = value;
#line 236 "../lib/chess-state.vala"
		g_string_append_printf (_tmp36_, "%c%d", 'a' + chess_state_get_file (self, self->en_passant_index), chess_state_get_rank (self, self->en_passant_index) + 1);
#line 1591 "chess-state.c"
	} else {
		GString* _tmp37_;
#line 238 "../lib/chess-state.vala"
		_tmp37_ = value;
#line 238 "../lib/chess-state.vala"
		g_string_append_c (_tmp37_, '-');
#line 1598 "chess-state.c"
	}
#line 240 "../lib/chess-state.vala"
	_tmp38_ = value;
#line 240 "../lib/chess-state.vala"
	g_string_append_c (_tmp38_, ' ');
#line 241 "../lib/chess-state.vala"
	_tmp39_ = value;
#line 241 "../lib/chess-state.vala"
	g_string_append_printf (_tmp39_, "%d", self->halfmove_clock);
#line 243 "../lib/chess-state.vala"
	_tmp40_ = value;
#line 243 "../lib/chess-state.vala"
	g_string_append_c (_tmp40_, ' ');
#line 244 "../lib/chess-state.vala"
	_tmp41_ = self->current_player;
#line 244 "../lib/chess-state.vala"
	_tmp42_ = _tmp41_->color;
#line 244 "../lib/chess-state.vala"
	if (_tmp42_ == COLOR_WHITE) {
#line 1618 "chess-state.c"
		GString* _tmp43_;
#line 245 "../lib/chess-state.vala"
		_tmp43_ = value;
#line 245 "../lib/chess-state.vala"
		g_string_append_printf (_tmp43_, "%d", self->number / 2);
#line 1624 "chess-state.c"
	} else {
		GString* _tmp44_;
#line 247 "../lib/chess-state.vala"
		_tmp44_ = value;
#line 247 "../lib/chess-state.vala"
		g_string_append_printf (_tmp44_, "%d", (self->number / 2) + 1);
#line 1631 "chess-state.c"
	}
#line 249 "../lib/chess-state.vala"
	_tmp45_ = value;
#line 249 "../lib/chess-state.vala"
	_tmp46_ = _tmp45_->str;
#line 249 "../lib/chess-state.vala"
	_tmp47_ = g_strdup (_tmp46_);
#line 249 "../lib/chess-state.vala"
	result = _tmp47_;
#line 249 "../lib/chess-state.vala"
	_g_string_free0 (value);
#line 249 "../lib/chess-state.vala"
	return result;
#line 1645 "chess-state.c"
}

gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result = 0;
#line 252 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 254 "../lib/chess-state.vala"
	result = (rank * 8) + file;
#line 254 "../lib/chess-state.vala"
	return result;
#line 1660 "chess-state.c"
}

gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result = 0;
#line 257 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../lib/chess-state.vala"
	result = index / 8;
#line 259 "../lib/chess-state.vala"
	return result;
#line 1674 "chess-state.c"
}

gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result = 0;
#line 262 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 264 "../lib/chess-state.vala"
	result = index % 8;
#line 264 "../lib/chess-state.vala"
	return result;
#line 1688 "chess-state.c"
}

gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gboolean result = FALSE;
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	PieceType _tmp8_;
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 272 "../lib/chess-state.vala"
	_tmp0_ = self->current_player;
#line 272 "../lib/chess-state.vala"
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 272 "../lib/chess-state.vala"
	r0 = _tmp1_;
#line 272 "../lib/chess-state.vala"
	f0 = _tmp2_;
#line 272 "../lib/chess-state.vala"
	r1 = _tmp3_;
#line 272 "../lib/chess-state.vala"
	f1 = _tmp4_;
#line 272 "../lib/chess-state.vala"
	promotion_type = _tmp5_;
#line 272 "../lib/chess-state.vala"
	if (!_tmp6_) {
#line 273 "../lib/chess-state.vala"
		result = FALSE;
#line 273 "../lib/chess-state.vala"
		return result;
#line 1735 "chess-state.c"
	}
#line 275 "../lib/chess-state.vala"
	_tmp7_ = self->current_player;
#line 275 "../lib/chess-state.vala"
	_tmp8_ = promotion_type;
#line 275 "../lib/chess-state.vala"
	if (!chess_state_move_with_coords (self, _tmp7_, r0, f0, r1, f1, _tmp8_, apply, TRUE)) {
#line 276 "../lib/chess-state.vala"
		result = FALSE;
#line 276 "../lib/chess-state.vala"
		return result;
#line 1747 "chess-state.c"
	}
#line 278 "../lib/chess-state.vala"
	result = TRUE;
#line 278 "../lib/chess-state.vala"
	return result;
#line 1753 "chess-state.c"
}

gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gboolean result = FALSE;
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_;
	Color _tmp1_ = 0;
	Color _tmp2_;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	ChessPiece* _tmp3_;
	ChessPiece* _tmp4_;
	gboolean _tmp5_ = FALSE;
	ChessPiece* _tmp6_;
	gint64 end_mask = 0LL;
	gint64 _tmp9_;
	gint64 move_mask = 0LL;
	Color _tmp10_;
	ChessPiece* _tmp11_;
	PieceType _tmp12_;
	gint64 _tmp13_;
	gint64 over_mask = 0LL;
	gint64 _tmp14_;
	gint64 _tmp15_;
	gint64 _tmp16_;
	ChessPiece* victim = NULL;
	ChessPiece* _tmp17_;
	ChessPiece* _tmp18_;
	gint victim_index = 0;
	gboolean _tmp19_ = FALSE;
	ChessPiece* _tmp20_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp23_;
	PieceType _tmp24_;
	gboolean _tmp55_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp69_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp70_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp71_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp72_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp73_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp74_;
	gint old_en_passant_index = 0;
	gint old_halfmove_clock = 0;
	gint64 _tmp75_;
	gint64 _tmp76_;
	ChessPiece* _tmp77_;
	Color _tmp83_;
	Color _tmp84_;
	gint64 _tmp85_;
	ChessPiece* _tmp94_;
	PieceType _tmp95_;
	gboolean _tmp112_ = FALSE;
	ChessPiece* _tmp113_;
	PieceType _tmp114_;
	gboolean _tmp115_ = FALSE;
	ChessPiece* _tmp116_;
	PieceType _tmp117_;
	gboolean _result_ = FALSE;
	gboolean _tmp120_ = FALSE;
	gboolean _tmp121_ = FALSE;
	ChessPlayer* _tmp131_ = NULL;
	Color _tmp132_;
	ChessPlayer* _tmp135_;
	ChessPlayer* _tmp136_;
	ChessMove* _tmp137_;
	ChessMove* _tmp138_;
	ChessMove* _tmp139_;
	ChessPiece* _tmp140_;
	ChessPiece* _tmp141_;
	ChessMove* _tmp145_;
	ChessPiece* _tmp146_;
	ChessPiece* _tmp147_;
	ChessMove* _tmp151_;
	ChessMove* _tmp152_;
	ChessMove* _tmp153_;
	ChessMove* _tmp154_;
	ChessMove* _tmp155_;
	ChessMove* _tmp156_;
	ChessMove* _tmp157_;
	ChessMove* _tmp158_;
	CheckState _tmp159_;
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 287 "../lib/chess-state.vala"
	start = chess_state_get_index (self, r0, f0);
#line 288 "../lib/chess-state.vala"
	end = chess_state_get_index (self, r1, f1);
#line 290 "../lib/chess-state.vala"
	_tmp0_ = player->color;
#line 290 "../lib/chess-state.vala"
	color = _tmp0_;
#line 291 "../lib/chess-state.vala"
	_tmp2_ = color;
#line 291 "../lib/chess-state.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 291 "../lib/chess-state.vala"
		_tmp1_ = COLOR_BLACK;
#line 1876 "chess-state.c"
	} else {
#line 291 "../lib/chess-state.vala"
		_tmp1_ = COLOR_WHITE;
#line 1880 "chess-state.c"
	}
#line 291 "../lib/chess-state.vala"
	opponent_color = _tmp1_;
#line 294 "../lib/chess-state.vala"
	_tmp3_ = self->board[start];
#line 294 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 294 "../lib/chess-state.vala"
	piece = _tmp4_;
#line 295 "../lib/chess-state.vala"
	_tmp6_ = piece;
#line 295 "../lib/chess-state.vala"
	if (_tmp6_ == NULL) {
#line 295 "../lib/chess-state.vala"
		_tmp5_ = TRUE;
#line 1896 "chess-state.c"
	} else {
		ChessPiece* _tmp7_;
		ChessPlayer* _tmp8_;
#line 295 "../lib/chess-state.vala"
		_tmp7_ = piece;
#line 295 "../lib/chess-state.vala"
		_tmp8_ = _tmp7_->player;
#line 295 "../lib/chess-state.vala"
		_tmp5_ = _tmp8_ != player;
#line 1906 "chess-state.c"
	}
#line 295 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 296 "../lib/chess-state.vala"
		result = FALSE;
#line 296 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 296 "../lib/chess-state.vala"
		return result;
#line 1916 "chess-state.c"
	}
#line 299 "../lib/chess-state.vala"
	_tmp9_ = BIT_BOARD_set_location_masks[end];
#line 299 "../lib/chess-state.vala"
	end_mask = _tmp9_;
#line 300 "../lib/chess-state.vala"
	_tmp10_ = color;
#line 300 "../lib/chess-state.vala"
	_tmp11_ = piece;
#line 300 "../lib/chess-state.vala"
	_tmp12_ = _tmp11_->type;
#line 300 "../lib/chess-state.vala"
	_tmp13_ = BIT_BOARD_move_masks[(((_tmp10_ * 64) * 6) + (_tmp12_ * 64)) + start];
#line 300 "../lib/chess-state.vala"
	move_mask = _tmp13_;
#line 301 "../lib/chess-state.vala"
	if ((end_mask & move_mask) == ((gint64) 0)) {
#line 302 "../lib/chess-state.vala"
		result = FALSE;
#line 302 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 302 "../lib/chess-state.vala"
		return result;
#line 1940 "chess-state.c"
	}
#line 305 "../lib/chess-state.vala"
	_tmp14_ = BIT_BOARD_over_masks[(start * 64) + end];
#line 305 "../lib/chess-state.vala"
	over_mask = _tmp14_;
#line 306 "../lib/chess-state.vala"
	_tmp15_ = self->priv->piece_masks[COLOR_WHITE];
#line 306 "../lib/chess-state.vala"
	_tmp16_ = self->priv->piece_masks[COLOR_BLACK];
#line 306 "../lib/chess-state.vala"
	if ((over_mask & (_tmp15_ | _tmp16_)) != ((gint64) 0)) {
#line 307 "../lib/chess-state.vala"
		result = FALSE;
#line 307 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 307 "../lib/chess-state.vala"
		return result;
#line 1958 "chess-state.c"
	}
#line 310 "../lib/chess-state.vala"
	_tmp17_ = self->board[end];
#line 310 "../lib/chess-state.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 310 "../lib/chess-state.vala"
	victim = _tmp18_;
#line 311 "../lib/chess-state.vala"
	victim_index = end;
#line 314 "../lib/chess-state.vala"
	_tmp20_ = victim;
#line 314 "../lib/chess-state.vala"
	if (_tmp20_ != NULL) {
#line 1972 "chess-state.c"
		ChessPiece* _tmp21_;
		ChessPlayer* _tmp22_;
#line 314 "../lib/chess-state.vala"
		_tmp21_ = victim;
#line 314 "../lib/chess-state.vala"
		_tmp22_ = _tmp21_->player;
#line 314 "../lib/chess-state.vala"
		_tmp19_ = _tmp22_ == player;
#line 1981 "chess-state.c"
	} else {
#line 314 "../lib/chess-state.vala"
		_tmp19_ = FALSE;
#line 1985 "chess-state.c"
	}
#line 314 "../lib/chess-state.vala"
	if (_tmp19_) {
#line 315 "../lib/chess-state.vala"
		result = FALSE;
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 315 "../lib/chess-state.vala"
		return result;
#line 1997 "chess-state.c"
	}
#line 318 "../lib/chess-state.vala"
	rook_start = -1;
#line 318 "../lib/chess-state.vala"
	rook_end = -1;
#line 319 "../lib/chess-state.vala"
	is_promotion = FALSE;
#line 320 "../lib/chess-state.vala"
	en_passant = FALSE;
#line 321 "../lib/chess-state.vala"
	ambiguous_rank = FALSE;
#line 322 "../lib/chess-state.vala"
	ambiguous_file = FALSE;
#line 323 "../lib/chess-state.vala"
	_tmp23_ = piece;
#line 323 "../lib/chess-state.vala"
	_tmp24_ = _tmp23_->type;
#line 323 "../lib/chess-state.vala"
	switch (_tmp24_) {
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_PAWN:
#line 2019 "chess-state.c"
		{
			gboolean _tmp25_ = FALSE;
			ChessPiece* _tmp26_;
			gboolean _tmp32_ = FALSE;
			ChessPiece* _tmp33_;
#line 327 "../lib/chess-state.vala"
			_tmp26_ = victim;
#line 327 "../lib/chess-state.vala"
			if (_tmp26_ == NULL) {
#line 327 "../lib/chess-state.vala"
				_tmp25_ = end == self->en_passant_index;
#line 2031 "chess-state.c"
			} else {
#line 327 "../lib/chess-state.vala"
				_tmp25_ = FALSE;
#line 2035 "chess-state.c"
			}
#line 327 "../lib/chess-state.vala"
			if (_tmp25_) {
#line 2039 "chess-state.c"
				gint _tmp27_ = 0;
				ChessPiece* _tmp28_;
				ChessPiece* _tmp29_;
#line 329 "../lib/chess-state.vala"
				en_passant = TRUE;
#line 330 "../lib/chess-state.vala"
				if (r1 == 2) {
#line 330 "../lib/chess-state.vala"
					_tmp27_ = 3;
#line 2049 "chess-state.c"
				} else {
#line 330 "../lib/chess-state.vala"
					_tmp27_ = 4;
#line 2053 "chess-state.c"
				}
#line 330 "../lib/chess-state.vala"
				victim_index = chess_state_get_index (self, _tmp27_, f1);
#line 331 "../lib/chess-state.vala"
				_tmp28_ = self->board[victim_index];
#line 331 "../lib/chess-state.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 331 "../lib/chess-state.vala"
				_g_object_unref0 (victim);
#line 331 "../lib/chess-state.vala"
				victim = _tmp29_;
#line 2065 "chess-state.c"
			}
#line 335 "../lib/chess-state.vala"
			if (f0 != f1) {
#line 2069 "chess-state.c"
				ChessPiece* _tmp30_;
#line 337 "../lib/chess-state.vala"
				_tmp30_ = victim;
#line 337 "../lib/chess-state.vala"
				if (_tmp30_ == NULL) {
#line 338 "../lib/chess-state.vala"
					result = FALSE;
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 338 "../lib/chess-state.vala"
					return result;
#line 2083 "chess-state.c"
				}
			} else {
				ChessPiece* _tmp31_;
#line 343 "../lib/chess-state.vala"
				_tmp31_ = victim;
#line 343 "../lib/chess-state.vala"
				if (_tmp31_ != NULL) {
#line 344 "../lib/chess-state.vala"
					result = FALSE;
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 344 "../lib/chess-state.vala"
					return result;
#line 2099 "chess-state.c"
				}
			}
#line 346 "../lib/chess-state.vala"
			if (r1 == 0) {
#line 346 "../lib/chess-state.vala"
				_tmp32_ = TRUE;
#line 2106 "chess-state.c"
			} else {
#line 346 "../lib/chess-state.vala"
				_tmp32_ = r1 == 7;
#line 2110 "chess-state.c"
			}
#line 346 "../lib/chess-state.vala"
			is_promotion = _tmp32_;
#line 349 "../lib/chess-state.vala"
			_tmp33_ = victim;
#line 349 "../lib/chess-state.vala"
			if (_tmp33_ != NULL) {
#line 350 "../lib/chess-state.vala"
				ambiguous_file = TRUE;
#line 2120 "chess-state.c"
			}
#line 351 "../lib/chess-state.vala"
			break;
#line 2124 "chess-state.c"
		}
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_KING:
#line 2128 "chess-state.c"
		{
#line 354 "../lib/chess-state.vala"
			if (abs (f0 - f1) > 1) {
#line 2132 "chess-state.c"
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				ChessPiece* rook = NULL;
				ChessPiece* _tmp40_;
				ChessPiece* _tmp41_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_ = FALSE;
				ChessPiece* _tmp44_;
				gint64 rook_over_mask = 0LL;
				gint64 _tmp51_;
				gint64 _tmp52_;
				gint64 _tmp53_;
				CheckState _tmp54_;
#line 357 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 357 "../lib/chess-state.vala"
					_tmp34_ = 7;
#line 2150 "chess-state.c"
				} else {
#line 357 "../lib/chess-state.vala"
					_tmp34_ = 0;
#line 2154 "chess-state.c"
				}
#line 357 "../lib/chess-state.vala"
				rook_start = chess_state_get_index (self, r0, _tmp34_);
#line 358 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 358 "../lib/chess-state.vala"
					_tmp35_ = f1 - 1;
#line 2162 "chess-state.c"
				} else {
#line 358 "../lib/chess-state.vala"
					_tmp35_ = f1 + 1;
#line 2166 "chess-state.c"
				}
#line 358 "../lib/chess-state.vala"
				rook_end = chess_state_get_index (self, r0, _tmp35_);
#line 361 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 2172 "chess-state.c"
					Color _tmp36_;
					gboolean _tmp37_;
#line 363 "../lib/chess-state.vala"
					_tmp36_ = color;
#line 363 "../lib/chess-state.vala"
					_tmp37_ = self->can_castle_kingside[_tmp36_];
#line 363 "../lib/chess-state.vala"
					if (!_tmp37_) {
#line 364 "../lib/chess-state.vala"
						result = FALSE;
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 364 "../lib/chess-state.vala"
						return result;
#line 2189 "chess-state.c"
					}
				} else {
					Color _tmp38_;
					gboolean _tmp39_;
#line 368 "../lib/chess-state.vala"
					_tmp38_ = color;
#line 368 "../lib/chess-state.vala"
					_tmp39_ = self->can_castle_queenside[_tmp38_];
#line 368 "../lib/chess-state.vala"
					if (!_tmp39_) {
#line 369 "../lib/chess-state.vala"
						result = FALSE;
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 369 "../lib/chess-state.vala"
						return result;
#line 2208 "chess-state.c"
					}
				}
#line 372 "../lib/chess-state.vala"
				_tmp40_ = self->board[rook_start];
#line 372 "../lib/chess-state.vala"
				_tmp41_ = _g_object_ref0 (_tmp40_);
#line 372 "../lib/chess-state.vala"
				rook = _tmp41_;
#line 373 "../lib/chess-state.vala"
				_tmp44_ = rook;
#line 373 "../lib/chess-state.vala"
				if (_tmp44_ == NULL) {
#line 373 "../lib/chess-state.vala"
					_tmp43_ = TRUE;
#line 2223 "chess-state.c"
				} else {
					ChessPiece* _tmp45_;
					PieceType _tmp46_;
#line 373 "../lib/chess-state.vala"
					_tmp45_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp46_ = _tmp45_->type;
#line 373 "../lib/chess-state.vala"
					_tmp43_ = _tmp46_ != PIECE_TYPE_ROOK;
#line 2233 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp43_) {
#line 373 "../lib/chess-state.vala"
					_tmp42_ = TRUE;
#line 2239 "chess-state.c"
				} else {
					ChessPiece* _tmp47_;
					Color _tmp48_;
					Color _tmp49_;
					Color _tmp50_;
#line 373 "../lib/chess-state.vala"
					_tmp47_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp48_ = chess_piece_get_color (_tmp47_);
#line 373 "../lib/chess-state.vala"
					_tmp49_ = _tmp48_;
#line 373 "../lib/chess-state.vala"
					_tmp50_ = color;
#line 373 "../lib/chess-state.vala"
					_tmp42_ = _tmp49_ != _tmp50_;
#line 2255 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp42_) {
#line 374 "../lib/chess-state.vala"
					result = FALSE;
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 374 "../lib/chess-state.vala"
					return result;
#line 2269 "chess-state.c"
				}
#line 377 "../lib/chess-state.vala"
				_tmp51_ = BIT_BOARD_over_masks[(rook_start * 64) + rook_end];
#line 377 "../lib/chess-state.vala"
				rook_over_mask = _tmp51_;
#line 378 "../lib/chess-state.vala"
				_tmp52_ = self->priv->piece_masks[COLOR_WHITE];
#line 378 "../lib/chess-state.vala"
				_tmp53_ = self->priv->piece_masks[COLOR_BLACK];
#line 378 "../lib/chess-state.vala"
				if ((rook_over_mask & (_tmp52_ | _tmp53_)) != ((gint64) 0)) {
#line 379 "../lib/chess-state.vala"
					result = FALSE;
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 379 "../lib/chess-state.vala"
					return result;
#line 2291 "chess-state.c"
				}
#line 382 "../lib/chess-state.vala"
				_tmp54_ = self->check_state;
#line 382 "../lib/chess-state.vala"
				if (_tmp54_ == CHECK_STATE_CHECK) {
#line 383 "../lib/chess-state.vala"
					result = FALSE;
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 383 "../lib/chess-state.vala"
					return result;
#line 2307 "chess-state.c"
				}
#line 386 "../lib/chess-state.vala"
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, rook_end), chess_state_get_file (self, rook_end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 387 "../lib/chess-state.vala"
					result = FALSE;
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 387 "../lib/chess-state.vala"
					return result;
#line 2321 "chess-state.c"
				}
#line 354 "../lib/chess-state.vala"
				_g_object_unref0 (rook);
#line 2325 "chess-state.c"
			}
#line 389 "../lib/chess-state.vala"
			break;
#line 2329 "chess-state.c"
		}
		default:
		{
#line 391 "../lib/chess-state.vala"
			break;
#line 2335 "chess-state.c"
		}
	}
#line 394 "../lib/chess-state.vala"
	if (!apply) {
#line 394 "../lib/chess-state.vala"
		_tmp55_ = !test_check;
#line 2342 "chess-state.c"
	} else {
#line 394 "../lib/chess-state.vala"
		_tmp55_ = FALSE;
#line 2346 "chess-state.c"
	}
#line 394 "../lib/chess-state.vala"
	if (_tmp55_) {
#line 395 "../lib/chess-state.vala"
		result = TRUE;
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 395 "../lib/chess-state.vala"
		return result;
#line 2358 "chess-state.c"
	}
#line 398 "../lib/chess-state.vala"
	if (apply) {
#line 2362 "chess-state.c"
		{
			gint i = 0;
#line 400 "../lib/chess-state.vala"
			i = 0;
#line 2367 "chess-state.c"
			{
				gboolean _tmp56_ = FALSE;
#line 400 "../lib/chess-state.vala"
				_tmp56_ = TRUE;
#line 400 "../lib/chess-state.vala"
				while (TRUE) {
#line 2374 "chess-state.c"
					ChessPiece* p = NULL;
					ChessPiece* _tmp58_;
					ChessPiece* _tmp59_;
					gboolean _tmp60_ = FALSE;
					gboolean _tmp61_ = FALSE;
					ChessPiece* _tmp62_;
					gint r = 0;
					gint f = 0;
#line 400 "../lib/chess-state.vala"
					if (!_tmp56_) {
#line 2385 "chess-state.c"
						gint _tmp57_;
#line 400 "../lib/chess-state.vala"
						_tmp57_ = i;
#line 400 "../lib/chess-state.vala"
						i = _tmp57_ + 1;
#line 2391 "chess-state.c"
					}
#line 400 "../lib/chess-state.vala"
					_tmp56_ = FALSE;
#line 400 "../lib/chess-state.vala"
					if (!(i < 64)) {
#line 400 "../lib/chess-state.vala"
						break;
#line 2399 "chess-state.c"
					}
#line 403 "../lib/chess-state.vala"
					if (i == start) {
#line 404 "../lib/chess-state.vala"
						continue;
#line 2405 "chess-state.c"
					}
#line 407 "../lib/chess-state.vala"
					_tmp58_ = self->board[i];
#line 407 "../lib/chess-state.vala"
					_tmp59_ = _g_object_ref0 (_tmp58_);
#line 407 "../lib/chess-state.vala"
					p = _tmp59_;
#line 408 "../lib/chess-state.vala"
					_tmp62_ = p;
#line 408 "../lib/chess-state.vala"
					if (_tmp62_ == NULL) {
#line 408 "../lib/chess-state.vala"
						_tmp61_ = TRUE;
#line 2419 "chess-state.c"
					} else {
						ChessPiece* _tmp63_;
						ChessPlayer* _tmp64_;
#line 408 "../lib/chess-state.vala"
						_tmp63_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp64_ = _tmp63_->player;
#line 408 "../lib/chess-state.vala"
						_tmp61_ = _tmp64_ != player;
#line 2429 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp61_) {
#line 408 "../lib/chess-state.vala"
						_tmp60_ = TRUE;
#line 2435 "chess-state.c"
					} else {
						ChessPiece* _tmp65_;
						PieceType _tmp66_;
						ChessPiece* _tmp67_;
						PieceType _tmp68_;
#line 408 "../lib/chess-state.vala"
						_tmp65_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp66_ = _tmp65_->type;
#line 408 "../lib/chess-state.vala"
						_tmp67_ = piece;
#line 408 "../lib/chess-state.vala"
						_tmp68_ = _tmp67_->type;
#line 408 "../lib/chess-state.vala"
						_tmp60_ = _tmp66_ != _tmp68_;
#line 2451 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp60_) {
#line 409 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 409 "../lib/chess-state.vala"
						continue;
#line 2459 "chess-state.c"
					}
#line 412 "../lib/chess-state.vala"
					r = chess_state_get_rank (self, i);
#line 413 "../lib/chess-state.vala"
					f = chess_state_get_file (self, i);
#line 414 "../lib/chess-state.vala"
					if (chess_state_move_with_coords (self, player, r, f, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 416 "../lib/chess-state.vala"
						if (r != r0) {
#line 417 "../lib/chess-state.vala"
							ambiguous_rank = TRUE;
#line 2471 "chess-state.c"
						}
#line 418 "../lib/chess-state.vala"
						if (f != f0) {
#line 419 "../lib/chess-state.vala"
							ambiguous_file = TRUE;
#line 2477 "chess-state.c"
						}
					}
#line 400 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 2482 "chess-state.c"
				}
			}
		}
	}
#line 424 "../lib/chess-state.vala"
	_tmp69_ = self->priv->piece_masks[COLOR_WHITE];
#line 424 "../lib/chess-state.vala"
	old_white_mask = _tmp69_;
#line 425 "../lib/chess-state.vala"
	_tmp70_ = self->priv->piece_masks[COLOR_BLACK];
#line 425 "../lib/chess-state.vala"
	old_black_mask = _tmp70_;
#line 426 "../lib/chess-state.vala"
	_tmp71_ = self->can_castle_kingside[COLOR_WHITE];
#line 426 "../lib/chess-state.vala"
	old_white_can_castle_kingside = _tmp71_;
#line 427 "../lib/chess-state.vala"
	_tmp72_ = self->can_castle_queenside[COLOR_WHITE];
#line 427 "../lib/chess-state.vala"
	old_white_can_castle_queenside = _tmp72_;
#line 428 "../lib/chess-state.vala"
	_tmp73_ = self->can_castle_kingside[COLOR_BLACK];
#line 428 "../lib/chess-state.vala"
	old_black_can_castle_kingside = _tmp73_;
#line 429 "../lib/chess-state.vala"
	_tmp74_ = self->can_castle_queenside[COLOR_BLACK];
#line 429 "../lib/chess-state.vala"
	old_black_can_castle_queenside = _tmp74_;
#line 430 "../lib/chess-state.vala"
	old_en_passant_index = self->en_passant_index;
#line 431 "../lib/chess-state.vala"
	old_halfmove_clock = self->halfmove_clock;
#line 434 "../lib/chess-state.vala"
	_g_object_unref0 (self->board[start]);
#line 434 "../lib/chess-state.vala"
	self->board[start] = NULL;
#line 435 "../lib/chess-state.vala"
	_tmp75_ = BIT_BOARD_clear_location_masks[start];
#line 435 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_WHITE] &= _tmp75_;
#line 436 "../lib/chess-state.vala"
	_tmp76_ = BIT_BOARD_clear_location_masks[start];
#line 436 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_BLACK] &= _tmp76_;
#line 437 "../lib/chess-state.vala"
	_tmp77_ = victim;
#line 437 "../lib/chess-state.vala"
	if (_tmp77_ != NULL) {
#line 2531 "chess-state.c"
		gint64 _tmp78_;
		gint64 _tmp79_;
#line 439 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[victim_index]);
#line 439 "../lib/chess-state.vala"
		self->board[victim_index] = NULL;
#line 440 "../lib/chess-state.vala"
		_tmp78_ = BIT_BOARD_clear_location_masks[victim_index];
#line 440 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] &= _tmp78_;
#line 441 "../lib/chess-state.vala"
		_tmp79_ = BIT_BOARD_clear_location_masks[victim_index];
#line 441 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] &= _tmp79_;
#line 2546 "chess-state.c"
	}
#line 443 "../lib/chess-state.vala"
	if (is_promotion) {
#line 2550 "chess-state.c"
		ChessPiece* _tmp80_;
#line 444 "../lib/chess-state.vala"
		_tmp80_ = chess_piece_new (player, promotion_type);
#line 444 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 444 "../lib/chess-state.vala"
		self->board[end] = _tmp80_;
#line 2558 "chess-state.c"
	} else {
		ChessPiece* _tmp81_;
		ChessPiece* _tmp82_;
#line 446 "../lib/chess-state.vala"
		_tmp81_ = piece;
#line 446 "../lib/chess-state.vala"
		_tmp82_ = _g_object_ref0 (_tmp81_);
#line 446 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 446 "../lib/chess-state.vala"
		self->board[end] = _tmp82_;
#line 2570 "chess-state.c"
	}
#line 447 "../lib/chess-state.vala"
	_tmp83_ = color;
#line 447 "../lib/chess-state.vala"
	self->priv->piece_masks[_tmp83_] |= end_mask;
#line 448 "../lib/chess-state.vala"
	_tmp84_ = opponent_color;
#line 448 "../lib/chess-state.vala"
	_tmp85_ = BIT_BOARD_clear_location_masks[end];
#line 448 "../lib/chess-state.vala"
	self->priv->piece_masks[_tmp84_] &= _tmp85_;
#line 449 "../lib/chess-state.vala"
	if (rook_start >= 0) {
#line 2584 "chess-state.c"
		ChessPiece* rook = NULL;
		ChessPiece* _tmp86_;
		ChessPiece* _tmp87_;
		Color _tmp88_;
		gint64 _tmp89_;
		ChessPiece* _tmp90_;
		ChessPiece* _tmp91_;
		Color _tmp92_;
		gint64 _tmp93_;
#line 451 "../lib/chess-state.vala"
		_tmp86_ = self->board[rook_start];
#line 451 "../lib/chess-state.vala"
		_tmp87_ = _g_object_ref0 (_tmp86_);
#line 451 "../lib/chess-state.vala"
		rook = _tmp87_;
#line 452 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[rook_start]);
#line 452 "../lib/chess-state.vala"
		self->board[rook_start] = NULL;
#line 453 "../lib/chess-state.vala"
		_tmp88_ = color;
#line 453 "../lib/chess-state.vala"
		_tmp89_ = BIT_BOARD_clear_location_masks[rook_start];
#line 453 "../lib/chess-state.vala"
		self->priv->piece_masks[_tmp88_] &= _tmp89_;
#line 454 "../lib/chess-state.vala"
		_tmp90_ = rook;
#line 454 "../lib/chess-state.vala"
		_tmp91_ = _g_object_ref0 (_tmp90_);
#line 454 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[rook_end]);
#line 454 "../lib/chess-state.vala"
		self->board[rook_end] = _tmp91_;
#line 455 "../lib/chess-state.vala"
		_tmp92_ = color;
#line 455 "../lib/chess-state.vala"
		_tmp93_ = BIT_BOARD_set_location_masks[rook_end];
#line 455 "../lib/chess-state.vala"
		self->priv->piece_masks[_tmp92_] |= _tmp93_;
#line 449 "../lib/chess-state.vala"
		_g_object_unref0 (rook);
#line 2626 "chess-state.c"
	}
#line 459 "../lib/chess-state.vala"
	_tmp94_ = piece;
#line 459 "../lib/chess-state.vala"
	_tmp95_ = _tmp94_->type;
#line 459 "../lib/chess-state.vala"
	if (_tmp95_ == PIECE_TYPE_KING) {
#line 2634 "chess-state.c"
		Color _tmp96_;
		Color _tmp97_;
#line 461 "../lib/chess-state.vala"
		_tmp96_ = color;
#line 461 "../lib/chess-state.vala"
		self->can_castle_kingside[_tmp96_] = FALSE;
#line 462 "../lib/chess-state.vala"
		_tmp97_ = color;
#line 462 "../lib/chess-state.vala"
		self->can_castle_queenside[_tmp97_] = FALSE;
#line 2645 "chess-state.c"
	} else {
		ChessPiece* _tmp98_;
		PieceType _tmp99_;
#line 465 "../lib/chess-state.vala"
		_tmp98_ = piece;
#line 465 "../lib/chess-state.vala"
		_tmp99_ = _tmp98_->type;
#line 465 "../lib/chess-state.vala"
		if (_tmp99_ == PIECE_TYPE_ROOK) {
#line 2655 "chess-state.c"
			gint _tmp100_ = 0;
			Color _tmp101_;
			gint base_rank = 0;
#line 467 "../lib/chess-state.vala"
			_tmp101_ = color;
#line 467 "../lib/chess-state.vala"
			if (_tmp101_ == COLOR_WHITE) {
#line 467 "../lib/chess-state.vala"
				_tmp100_ = 0;
#line 2665 "chess-state.c"
			} else {
#line 467 "../lib/chess-state.vala"
				_tmp100_ = 7;
#line 2669 "chess-state.c"
			}
#line 467 "../lib/chess-state.vala"
			base_rank = _tmp100_;
#line 468 "../lib/chess-state.vala"
			if (r0 == base_rank) {
#line 470 "../lib/chess-state.vala"
				if (f0 == 0) {
#line 2677 "chess-state.c"
					Color _tmp102_;
#line 471 "../lib/chess-state.vala"
					_tmp102_ = color;
#line 471 "../lib/chess-state.vala"
					self->can_castle_queenside[_tmp102_] = FALSE;
#line 2683 "chess-state.c"
				} else {
#line 472 "../lib/chess-state.vala"
					if (f0 == 7) {
#line 2687 "chess-state.c"
						Color _tmp103_;
#line 473 "../lib/chess-state.vala"
						_tmp103_ = color;
#line 473 "../lib/chess-state.vala"
						self->can_castle_kingside[_tmp103_] = FALSE;
#line 2693 "chess-state.c"
					}
				}
			}
		} else {
			gboolean _tmp104_ = FALSE;
			ChessPiece* _tmp105_;
#line 477 "../lib/chess-state.vala"
			_tmp105_ = victim;
#line 477 "../lib/chess-state.vala"
			if (_tmp105_ != NULL) {
#line 2704 "chess-state.c"
				ChessPiece* _tmp106_;
				PieceType _tmp107_;
#line 477 "../lib/chess-state.vala"
				_tmp106_ = victim;
#line 477 "../lib/chess-state.vala"
				_tmp107_ = _tmp106_->type;
#line 477 "../lib/chess-state.vala"
				_tmp104_ = _tmp107_ == PIECE_TYPE_ROOK;
#line 2713 "chess-state.c"
			} else {
#line 477 "../lib/chess-state.vala"
				_tmp104_ = FALSE;
#line 2717 "chess-state.c"
			}
#line 477 "../lib/chess-state.vala"
			if (_tmp104_) {
#line 2721 "chess-state.c"
				gint _tmp108_ = 0;
				Color _tmp109_;
				gint base_rank = 0;
#line 479 "../lib/chess-state.vala"
				_tmp109_ = opponent_color;
#line 479 "../lib/chess-state.vala"
				if (_tmp109_ == COLOR_WHITE) {
#line 479 "../lib/chess-state.vala"
					_tmp108_ = 0;
#line 2731 "chess-state.c"
				} else {
#line 479 "../lib/chess-state.vala"
					_tmp108_ = 7;
#line 2735 "chess-state.c"
				}
#line 479 "../lib/chess-state.vala"
				base_rank = _tmp108_;
#line 480 "../lib/chess-state.vala"
				if (r1 == base_rank) {
#line 482 "../lib/chess-state.vala"
					if (f1 == 0) {
#line 2743 "chess-state.c"
						Color _tmp110_;
#line 483 "../lib/chess-state.vala"
						_tmp110_ = opponent_color;
#line 483 "../lib/chess-state.vala"
						self->can_castle_queenside[_tmp110_] = FALSE;
#line 2749 "chess-state.c"
					} else {
#line 484 "../lib/chess-state.vala"
						if (f1 == 7) {
#line 2753 "chess-state.c"
							Color _tmp111_;
#line 485 "../lib/chess-state.vala"
							_tmp111_ = opponent_color;
#line 485 "../lib/chess-state.vala"
							self->can_castle_kingside[_tmp111_] = FALSE;
#line 2759 "chess-state.c"
						}
					}
				}
			}
		}
	}
#line 490 "../lib/chess-state.vala"
	_tmp113_ = piece;
#line 490 "../lib/chess-state.vala"
	_tmp114_ = _tmp113_->type;
#line 490 "../lib/chess-state.vala"
	if (_tmp114_ == PIECE_TYPE_PAWN) {
#line 490 "../lib/chess-state.vala"
		_tmp112_ = over_mask != ((gint64) 0);
#line 2774 "chess-state.c"
	} else {
#line 490 "../lib/chess-state.vala"
		_tmp112_ = FALSE;
#line 2778 "chess-state.c"
	}
#line 490 "../lib/chess-state.vala"
	if (_tmp112_) {
#line 491 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
#line 2784 "chess-state.c"
	} else {
#line 493 "../lib/chess-state.vala"
		self->en_passant_index = -1;
#line 2788 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	_tmp116_ = piece;
#line 496 "../lib/chess-state.vala"
	_tmp117_ = _tmp116_->type;
#line 496 "../lib/chess-state.vala"
	if (_tmp117_ == PIECE_TYPE_PAWN) {
#line 496 "../lib/chess-state.vala"
		_tmp115_ = TRUE;
#line 2798 "chess-state.c"
	} else {
		ChessPiece* _tmp118_;
#line 496 "../lib/chess-state.vala"
		_tmp118_ = victim;
#line 496 "../lib/chess-state.vala"
		_tmp115_ = _tmp118_ != NULL;
#line 2805 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	if (_tmp115_) {
#line 497 "../lib/chess-state.vala"
		self->halfmove_clock = 0;
#line 2811 "chess-state.c"
	} else {
		gint _tmp119_;
#line 499 "../lib/chess-state.vala"
		_tmp119_ = self->halfmove_clock;
#line 499 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp119_ + 1;
#line 2818 "chess-state.c"
	}
#line 502 "../lib/chess-state.vala"
	_result_ = TRUE;
#line 503 "../lib/chess-state.vala"
	if (test_check) {
#line 503 "../lib/chess-state.vala"
		_tmp120_ = chess_state_is_in_check (self, player);
#line 2826 "chess-state.c"
	} else {
#line 503 "../lib/chess-state.vala"
		_tmp120_ = FALSE;
#line 2830 "chess-state.c"
	}
#line 503 "../lib/chess-state.vala"
	if (_tmp120_) {
#line 504 "../lib/chess-state.vala"
		_result_ = FALSE;
#line 2836 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (!apply) {
#line 507 "../lib/chess-state.vala"
		_tmp121_ = TRUE;
#line 2842 "chess-state.c"
	} else {
#line 507 "../lib/chess-state.vala"
		_tmp121_ = !_result_;
#line 2846 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (_tmp121_) {
#line 2850 "chess-state.c"
		ChessPiece* _tmp122_;
		ChessPiece* _tmp123_;
		ChessPiece* _tmp124_;
#line 509 "../lib/chess-state.vala"
		_tmp122_ = piece;
#line 509 "../lib/chess-state.vala"
		_tmp123_ = _g_object_ref0 (_tmp122_);
#line 509 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[start]);
#line 509 "../lib/chess-state.vala"
		self->board[start] = _tmp123_;
#line 510 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 510 "../lib/chess-state.vala"
		self->board[end] = NULL;
#line 511 "../lib/chess-state.vala"
		_tmp124_ = victim;
#line 511 "../lib/chess-state.vala"
		if (_tmp124_ != NULL) {
#line 2870 "chess-state.c"
			ChessPiece* _tmp125_;
			ChessPiece* _tmp126_;
#line 512 "../lib/chess-state.vala"
			_tmp125_ = victim;
#line 512 "../lib/chess-state.vala"
			_tmp126_ = _g_object_ref0 (_tmp125_);
#line 512 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[victim_index]);
#line 512 "../lib/chess-state.vala"
			self->board[victim_index] = _tmp126_;
#line 2881 "chess-state.c"
		}
#line 513 "../lib/chess-state.vala"
		if (rook_start >= 0) {
#line 2885 "chess-state.c"
			ChessPiece* rook = NULL;
			ChessPiece* _tmp127_;
			ChessPiece* _tmp128_;
			ChessPiece* _tmp129_;
			ChessPiece* _tmp130_;
#line 515 "../lib/chess-state.vala"
			_tmp127_ = self->board[rook_end];
#line 515 "../lib/chess-state.vala"
			_tmp128_ = _g_object_ref0 (_tmp127_);
#line 515 "../lib/chess-state.vala"
			rook = _tmp128_;
#line 516 "../lib/chess-state.vala"
			_tmp129_ = rook;
#line 516 "../lib/chess-state.vala"
			_tmp130_ = _g_object_ref0 (_tmp129_);
#line 516 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[rook_start]);
#line 516 "../lib/chess-state.vala"
			self->board[rook_start] = _tmp130_;
#line 517 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[rook_end]);
#line 517 "../lib/chess-state.vala"
			self->board[rook_end] = NULL;
#line 513 "../lib/chess-state.vala"
			_g_object_unref0 (rook);
#line 2911 "chess-state.c"
		}
#line 519 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] = old_white_mask;
#line 520 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] = old_black_mask;
#line 521 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_WHITE] = old_white_can_castle_kingside;
#line 522 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_WHITE] = old_white_can_castle_queenside;
#line 523 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_BLACK] = old_black_can_castle_kingside;
#line 524 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_BLACK] = old_black_can_castle_queenside;
#line 525 "../lib/chess-state.vala"
		self->en_passant_index = old_en_passant_index;
#line 526 "../lib/chess-state.vala"
		self->halfmove_clock = old_halfmove_clock;
#line 528 "../lib/chess-state.vala"
		result = _result_;
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 528 "../lib/chess-state.vala"
		return result;
#line 2937 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp132_ = color;
#line 531 "../lib/chess-state.vala"
	if (_tmp132_ == COLOR_WHITE) {
#line 2943 "chess-state.c"
		ChessPlayer* _tmp133_;
#line 531 "../lib/chess-state.vala"
		_tmp133_ = self->players[COLOR_BLACK];
#line 531 "../lib/chess-state.vala"
		_tmp131_ = _tmp133_;
#line 2949 "chess-state.c"
	} else {
		ChessPlayer* _tmp134_;
#line 531 "../lib/chess-state.vala"
		_tmp134_ = self->players[COLOR_WHITE];
#line 531 "../lib/chess-state.vala"
		_tmp131_ = _tmp134_;
#line 2956 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp135_ = _g_object_ref0 (_tmp131_);
#line 531 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 531 "../lib/chess-state.vala"
	self->current_player = _tmp135_;
#line 532 "../lib/chess-state.vala"
	_tmp136_ = self->current_player;
#line 532 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp136_);
#line 534 "../lib/chess-state.vala"
	_tmp137_ = chess_move_new ();
#line 534 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 534 "../lib/chess-state.vala"
	self->last_move = _tmp137_;
#line 535 "../lib/chess-state.vala"
	_tmp138_ = self->last_move;
#line 535 "../lib/chess-state.vala"
	_tmp138_->number = self->number;
#line 536 "../lib/chess-state.vala"
	_tmp139_ = self->last_move;
#line 536 "../lib/chess-state.vala"
	_tmp140_ = piece;
#line 536 "../lib/chess-state.vala"
	_tmp141_ = _g_object_ref0 (_tmp140_);
#line 536 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp139_->piece);
#line 536 "../lib/chess-state.vala"
	_tmp139_->piece = _tmp141_;
#line 537 "../lib/chess-state.vala"
	if (is_promotion) {
#line 2990 "chess-state.c"
		ChessMove* _tmp142_;
		ChessPiece* _tmp143_;
		ChessPiece* _tmp144_;
#line 538 "../lib/chess-state.vala"
		_tmp142_ = self->last_move;
#line 538 "../lib/chess-state.vala"
		_tmp143_ = self->board[end];
#line 538 "../lib/chess-state.vala"
		_tmp144_ = _g_object_ref0 (_tmp143_);
#line 538 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp142_->promotion_piece);
#line 538 "../lib/chess-state.vala"
		_tmp142_->promotion_piece = _tmp144_;
#line 3004 "chess-state.c"
	}
#line 539 "../lib/chess-state.vala"
	_tmp145_ = self->last_move;
#line 539 "../lib/chess-state.vala"
	_tmp146_ = victim;
#line 539 "../lib/chess-state.vala"
	_tmp147_ = _g_object_ref0 (_tmp146_);
#line 539 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp145_->victim);
#line 539 "../lib/chess-state.vala"
	_tmp145_->victim = _tmp147_;
#line 540 "../lib/chess-state.vala"
	if (rook_end >= 0) {
#line 3018 "chess-state.c"
		ChessMove* _tmp148_;
		ChessPiece* _tmp149_;
		ChessPiece* _tmp150_;
#line 541 "../lib/chess-state.vala"
		_tmp148_ = self->last_move;
#line 541 "../lib/chess-state.vala"
		_tmp149_ = self->board[rook_end];
#line 541 "../lib/chess-state.vala"
		_tmp150_ = _g_object_ref0 (_tmp149_);
#line 541 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp148_->castling_rook);
#line 541 "../lib/chess-state.vala"
		_tmp148_->castling_rook = _tmp150_;
#line 3032 "chess-state.c"
	}
#line 542 "../lib/chess-state.vala"
	_tmp151_ = self->last_move;
#line 542 "../lib/chess-state.vala"
	_tmp151_->r0 = r0;
#line 543 "../lib/chess-state.vala"
	_tmp152_ = self->last_move;
#line 543 "../lib/chess-state.vala"
	_tmp152_->f0 = f0;
#line 544 "../lib/chess-state.vala"
	_tmp153_ = self->last_move;
#line 544 "../lib/chess-state.vala"
	_tmp153_->r1 = r1;
#line 545 "../lib/chess-state.vala"
	_tmp154_ = self->last_move;
#line 545 "../lib/chess-state.vala"
	_tmp154_->f1 = f1;
#line 546 "../lib/chess-state.vala"
	_tmp155_ = self->last_move;
#line 546 "../lib/chess-state.vala"
	_tmp155_->ambiguous_rank = ambiguous_rank;
#line 547 "../lib/chess-state.vala"
	_tmp156_ = self->last_move;
#line 547 "../lib/chess-state.vala"
	_tmp156_->ambiguous_file = ambiguous_file;
#line 548 "../lib/chess-state.vala"
	_tmp157_ = self->last_move;
#line 548 "../lib/chess-state.vala"
	_tmp157_->en_passant = en_passant;
#line 549 "../lib/chess-state.vala"
	_tmp158_ = self->last_move;
#line 549 "../lib/chess-state.vala"
	_tmp159_ = self->check_state;
#line 549 "../lib/chess-state.vala"
	_tmp158_->check_state = _tmp159_;
#line 551 "../lib/chess-state.vala"
	result = TRUE;
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (victim);
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (piece);
#line 551 "../lib/chess-state.vala"
	return result;
#line 3076 "chess-state.c"
}

ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessResult result = 0;
	CheckState _tmp0_;
	ChessPlayer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ChessMove* _tmp6_;
#line 554 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 556 "../lib/chess-state.vala"
	_vala_rule = CHESS_RULE_CHECKMATE;
#line 557 "../lib/chess-state.vala"
	_tmp0_ = self->check_state;
#line 557 "../lib/chess-state.vala"
	if (_tmp0_ == CHECK_STATE_CHECKMATE) {
#line 3098 "chess-state.c"
		ChessPlayer* _tmp1_;
		Color _tmp2_;
#line 559 "../lib/chess-state.vala"
		_tmp1_ = self->current_player;
#line 559 "../lib/chess-state.vala"
		_tmp2_ = _tmp1_->color;
#line 559 "../lib/chess-state.vala"
		if (_tmp2_ == COLOR_WHITE) {
#line 561 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 562 "../lib/chess-state.vala"
			result = CHESS_RESULT_BLACK_WON;
#line 562 "../lib/chess-state.vala"
			if (rule) {
#line 562 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 3115 "chess-state.c"
			}
#line 562 "../lib/chess-state.vala"
			return result;
#line 3119 "chess-state.c"
		} else {
#line 566 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 567 "../lib/chess-state.vala"
			result = CHESS_RESULT_WHITE_WON;
#line 567 "../lib/chess-state.vala"
			if (rule) {
#line 567 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 3129 "chess-state.c"
			}
#line 567 "../lib/chess-state.vala"
			return result;
#line 3133 "chess-state.c"
		}
	}
#line 571 "../lib/chess-state.vala"
	_tmp3_ = self->current_player;
#line 571 "../lib/chess-state.vala"
	if (!chess_state_can_move (self, _tmp3_)) {
#line 573 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_STALEMATE;
#line 574 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 574 "../lib/chess-state.vala"
		if (rule) {
#line 574 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 3148 "chess-state.c"
		}
#line 574 "../lib/chess-state.vala"
		return result;
#line 3152 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	_tmp6_ = self->last_move;
#line 577 "../lib/chess-state.vala"
	if (_tmp6_ != NULL) {
#line 3158 "chess-state.c"
		ChessMove* _tmp7_;
		ChessPiece* _tmp8_;
#line 577 "../lib/chess-state.vala"
		_tmp7_ = self->last_move;
#line 577 "../lib/chess-state.vala"
		_tmp8_ = _tmp7_->victim;
#line 577 "../lib/chess-state.vala"
		_tmp5_ = _tmp8_ != NULL;
#line 3167 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp5_ = FALSE;
#line 3171 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 577 "../lib/chess-state.vala"
		_tmp4_ = !chess_state_have_sufficient_material (self);
#line 3177 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp4_ = FALSE;
#line 3181 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 579 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
#line 580 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 580 "../lib/chess-state.vala"
		if (rule) {
#line 580 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 3193 "chess-state.c"
		}
#line 580 "../lib/chess-state.vala"
		return result;
#line 3197 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	result = CHESS_RESULT_IN_PROGRESS;
#line 583 "../lib/chess-state.vala"
	if (rule) {
#line 583 "../lib/chess-state.vala"
		*rule = _vala_rule;
#line 3205 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	return result;
#line 3209 "chess-state.c"
}

static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result = 0;
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, 0);
#line 588 "../lib/chess-state.vala"
	if (chess_state_is_in_check (self, player)) {
#line 590 "../lib/chess-state.vala"
		if (chess_state_is_in_checkmate (self, player)) {
#line 591 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECKMATE;
#line 591 "../lib/chess-state.vala"
			return result;
#line 3229 "chess-state.c"
		} else {
#line 593 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECK;
#line 593 "../lib/chess-state.vala"
			return result;
#line 3235 "chess-state.c"
		}
	}
#line 595 "../lib/chess-state.vala"
	result = CHECK_STATE_NONE;
#line 595 "../lib/chess-state.vala"
	return result;
#line 3242 "chess-state.c"
}

gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	gboolean result = FALSE;
	ChessPlayer* _tmp0_ = NULL;
	Color _tmp1_;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp4_;
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 600 "../lib/chess-state.vala"
	_tmp1_ = player->color;
#line 600 "../lib/chess-state.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 3262 "chess-state.c"
		ChessPlayer* _tmp2_;
#line 600 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_BLACK];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 3268 "chess-state.c"
	} else {
		ChessPlayer* _tmp3_;
#line 600 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_WHITE];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 3275 "chess-state.c"
	}
#line 600 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 600 "../lib/chess-state.vala"
	opponent = _tmp4_;
#line 3281 "chess-state.c"
	{
		gint king_index = 0;
#line 603 "../lib/chess-state.vala"
		king_index = 0;
#line 3286 "chess-state.c"
		{
			gboolean _tmp5_ = FALSE;
#line 603 "../lib/chess-state.vala"
			_tmp5_ = TRUE;
#line 603 "../lib/chess-state.vala"
			while (TRUE) {
#line 3293 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp7_;
				ChessPiece* _tmp8_;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
				ChessPiece* _tmp11_;
#line 603 "../lib/chess-state.vala"
				if (!_tmp5_) {
#line 3302 "chess-state.c"
					gint _tmp6_;
#line 603 "../lib/chess-state.vala"
					_tmp6_ = king_index;
#line 603 "../lib/chess-state.vala"
					king_index = _tmp6_ + 1;
#line 3308 "chess-state.c"
				}
#line 603 "../lib/chess-state.vala"
				_tmp5_ = FALSE;
#line 603 "../lib/chess-state.vala"
				if (!(king_index < 64)) {
#line 603 "../lib/chess-state.vala"
					break;
#line 3316 "chess-state.c"
				}
#line 605 "../lib/chess-state.vala"
				_tmp7_ = self->board[king_index];
#line 605 "../lib/chess-state.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 605 "../lib/chess-state.vala"
				p = _tmp8_;
#line 606 "../lib/chess-state.vala"
				_tmp11_ = p;
#line 606 "../lib/chess-state.vala"
				if (_tmp11_ != NULL) {
#line 3328 "chess-state.c"
					ChessPiece* _tmp12_;
					ChessPlayer* _tmp13_;
#line 606 "../lib/chess-state.vala"
					_tmp12_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp13_ = _tmp12_->player;
#line 606 "../lib/chess-state.vala"
					_tmp10_ = _tmp13_ == player;
#line 3337 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp10_ = FALSE;
#line 3341 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp10_) {
#line 3345 "chess-state.c"
					ChessPiece* _tmp14_;
					PieceType _tmp15_;
#line 606 "../lib/chess-state.vala"
					_tmp14_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp15_ = _tmp14_->type;
#line 606 "../lib/chess-state.vala"
					_tmp9_ = _tmp15_ == PIECE_TYPE_KING;
#line 3354 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp9_ = FALSE;
#line 3358 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp9_) {
#line 3362 "chess-state.c"
					{
						gint start = 0;
#line 609 "../lib/chess-state.vala"
						start = 0;
#line 3367 "chess-state.c"
						{
							gboolean _tmp16_ = FALSE;
#line 609 "../lib/chess-state.vala"
							_tmp16_ = TRUE;
#line 609 "../lib/chess-state.vala"
							while (TRUE) {
#line 3374 "chess-state.c"
								ChessPlayer* _tmp18_;
#line 609 "../lib/chess-state.vala"
								if (!_tmp16_) {
#line 3378 "chess-state.c"
									gint _tmp17_;
#line 609 "../lib/chess-state.vala"
									_tmp17_ = start;
#line 609 "../lib/chess-state.vala"
									start = _tmp17_ + 1;
#line 3384 "chess-state.c"
								}
#line 609 "../lib/chess-state.vala"
								_tmp16_ = FALSE;
#line 609 "../lib/chess-state.vala"
								if (!(start < 64)) {
#line 609 "../lib/chess-state.vala"
									break;
#line 3392 "chess-state.c"
								}
#line 611 "../lib/chess-state.vala"
								_tmp18_ = opponent;
#line 611 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, _tmp18_, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, king_index), chess_state_get_file (self, king_index), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
#line 615 "../lib/chess-state.vala"
									result = TRUE;
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (opponent);
#line 615 "../lib/chess-state.vala"
									return result;
#line 3406 "chess-state.c"
								}
							}
						}
					}
				}
#line 603 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3414 "chess-state.c"
			}
		}
	}
#line 620 "../lib/chess-state.vala"
	result = FALSE;
#line 620 "../lib/chess-state.vala"
	_g_object_unref0 (opponent);
#line 620 "../lib/chess-state.vala"
	return result;
#line 3424 "chess-state.c"
}

static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result = FALSE;
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 3436 "chess-state.c"
	{
		gint piece_index = 0;
#line 626 "../lib/chess-state.vala"
		piece_index = 0;
#line 3441 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 626 "../lib/chess-state.vala"
			while (TRUE) {
#line 3448 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
#line 626 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3456 "chess-state.c"
					gint _tmp1_;
#line 626 "../lib/chess-state.vala"
					_tmp1_ = piece_index;
#line 626 "../lib/chess-state.vala"
					piece_index = _tmp1_ + 1;
#line 3462 "chess-state.c"
				}
#line 626 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
				if (!(piece_index < 64)) {
#line 626 "../lib/chess-state.vala"
					break;
#line 3470 "chess-state.c"
				}
#line 628 "../lib/chess-state.vala"
				_tmp2_ = self->board[piece_index];
#line 628 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 628 "../lib/chess-state.vala"
				p = _tmp3_;
#line 629 "../lib/chess-state.vala"
				_tmp5_ = p;
#line 629 "../lib/chess-state.vala"
				if (_tmp5_ != NULL) {
#line 3482 "chess-state.c"
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
#line 629 "../lib/chess-state.vala"
					_tmp6_ = p;
#line 629 "../lib/chess-state.vala"
					_tmp7_ = _tmp6_->player;
#line 629 "../lib/chess-state.vala"
					_tmp4_ = _tmp7_ == player;
#line 3491 "chess-state.c"
				} else {
#line 629 "../lib/chess-state.vala"
					_tmp4_ = FALSE;
#line 3495 "chess-state.c"
				}
#line 629 "../lib/chess-state.vala"
				if (_tmp4_) {
#line 3499 "chess-state.c"
					{
						gint end = 0;
#line 631 "../lib/chess-state.vala"
						end = 0;
#line 3504 "chess-state.c"
						{
							gboolean _tmp8_ = FALSE;
#line 631 "../lib/chess-state.vala"
							_tmp8_ = TRUE;
#line 631 "../lib/chess-state.vala"
							while (TRUE) {
#line 631 "../lib/chess-state.vala"
								if (!_tmp8_) {
#line 3513 "chess-state.c"
									gint _tmp9_;
#line 631 "../lib/chess-state.vala"
									_tmp9_ = end;
#line 631 "../lib/chess-state.vala"
									end = _tmp9_ + 1;
#line 3519 "chess-state.c"
								}
#line 631 "../lib/chess-state.vala"
								_tmp8_ = FALSE;
#line 631 "../lib/chess-state.vala"
								if (!(end < 64)) {
#line 631 "../lib/chess-state.vala"
									break;
#line 3527 "chess-state.c"
								}
#line 633 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, piece_index), chess_state_get_file (self, piece_index), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 637 "../lib/chess-state.vala"
									result = FALSE;
#line 637 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 637 "../lib/chess-state.vala"
									return result;
#line 3537 "chess-state.c"
								}
							}
						}
					}
				}
#line 626 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3545 "chess-state.c"
			}
		}
	}
#line 642 "../lib/chess-state.vala"
	result = TRUE;
#line 642 "../lib/chess-state.vala"
	return result;
#line 3553 "chess-state.c"
}

static gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean result = FALSE;
	gboolean have_pieces = FALSE;
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 647 "../lib/chess-state.vala"
	have_pieces = FALSE;
#line 3568 "chess-state.c"
	{
		gint start = 0;
#line 649 "../lib/chess-state.vala"
		start = 0;
#line 3573 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 649 "../lib/chess-state.vala"
			while (TRUE) {
#line 3580 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
#line 649 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3588 "chess-state.c"
					gint _tmp1_;
#line 649 "../lib/chess-state.vala"
					_tmp1_ = start;
#line 649 "../lib/chess-state.vala"
					start = _tmp1_ + 1;
#line 3594 "chess-state.c"
				}
#line 649 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
				if (!(start < 64)) {
#line 649 "../lib/chess-state.vala"
					break;
#line 3602 "chess-state.c"
				}
#line 651 "../lib/chess-state.vala"
				_tmp2_ = self->board[start];
#line 651 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 651 "../lib/chess-state.vala"
				p = _tmp3_;
#line 652 "../lib/chess-state.vala"
				_tmp5_ = p;
#line 652 "../lib/chess-state.vala"
				if (_tmp5_ != NULL) {
#line 3614 "chess-state.c"
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
#line 652 "../lib/chess-state.vala"
					_tmp6_ = p;
#line 652 "../lib/chess-state.vala"
					_tmp7_ = _tmp6_->player;
#line 652 "../lib/chess-state.vala"
					_tmp4_ = _tmp7_ == player;
#line 3623 "chess-state.c"
				} else {
#line 652 "../lib/chess-state.vala"
					_tmp4_ = FALSE;
#line 3627 "chess-state.c"
				}
#line 652 "../lib/chess-state.vala"
				if (_tmp4_) {
#line 654 "../lib/chess-state.vala"
					have_pieces = TRUE;
#line 3633 "chess-state.c"
					{
						gint end = 0;
#line 657 "../lib/chess-state.vala"
						end = 0;
#line 3638 "chess-state.c"
						{
							gboolean _tmp8_ = FALSE;
#line 657 "../lib/chess-state.vala"
							_tmp8_ = TRUE;
#line 657 "../lib/chess-state.vala"
							while (TRUE) {
#line 657 "../lib/chess-state.vala"
								if (!_tmp8_) {
#line 3647 "chess-state.c"
									gint _tmp9_;
#line 657 "../lib/chess-state.vala"
									_tmp9_ = end;
#line 657 "../lib/chess-state.vala"
									end = _tmp9_ + 1;
#line 3653 "chess-state.c"
								}
#line 657 "../lib/chess-state.vala"
								_tmp8_ = FALSE;
#line 657 "../lib/chess-state.vala"
								if (!(end < 64)) {
#line 657 "../lib/chess-state.vala"
									break;
#line 3661 "chess-state.c"
								}
#line 659 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 663 "../lib/chess-state.vala"
									result = TRUE;
#line 663 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 663 "../lib/chess-state.vala"
									return result;
#line 3671 "chess-state.c"
								}
							}
						}
					}
				}
#line 649 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3679 "chess-state.c"
			}
		}
	}
#line 669 "../lib/chess-state.vala"
	if (have_pieces) {
#line 670 "../lib/chess-state.vala"
		result = FALSE;
#line 670 "../lib/chess-state.vala"
		return result;
#line 3689 "chess-state.c"
	} else {
#line 672 "../lib/chess-state.vala"
		result = TRUE;
#line 672 "../lib/chess-state.vala"
		return result;
#line 3695 "chess-state.c"
	}
}

gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gboolean result = FALSE;
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
#line 675 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 677 "../lib/chess-state.vala"
	white_knight_count = 0;
#line 678 "../lib/chess-state.vala"
	white_bishop_count = 0;
#line 679 "../lib/chess-state.vala"
	white_bishop_on_white_square = FALSE;
#line 680 "../lib/chess-state.vala"
	white_bishop_on_black_square = FALSE;
#line 681 "../lib/chess-state.vala"
	black_knight_count = 0;
#line 682 "../lib/chess-state.vala"
	black_bishop_count = 0;
#line 683 "../lib/chess-state.vala"
	black_bishop_on_white_square = FALSE;
#line 684 "../lib/chess-state.vala"
	black_bishop_on_black_square = FALSE;
#line 3729 "chess-state.c"
	{
		gint i = 0;
#line 686 "../lib/chess-state.vala"
		i = 0;
#line 3734 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 686 "../lib/chess-state.vala"
			while (TRUE) {
#line 3741 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				ChessPiece* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				PieceType _tmp8_;
				ChessPiece* _tmp13_;
				PieceType _tmp14_;
				ChessPiece* _tmp20_;
				PieceType _tmp21_;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_ = FALSE;
				gboolean _tmp32_ = FALSE;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				gboolean _tmp37_ = FALSE;
				gboolean _tmp38_ = FALSE;
#line 686 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3766 "chess-state.c"
					gint _tmp1_;
#line 686 "../lib/chess-state.vala"
					_tmp1_ = i;
#line 686 "../lib/chess-state.vala"
					i = _tmp1_ + 1;
#line 3772 "chess-state.c"
				}
#line 686 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 686 "../lib/chess-state.vala"
					break;
#line 3780 "chess-state.c"
				}
#line 688 "../lib/chess-state.vala"
				_tmp2_ = self->board[i];
#line 688 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 688 "../lib/chess-state.vala"
				p = _tmp3_;
#line 689 "../lib/chess-state.vala"
				_tmp4_ = p;
#line 689 "../lib/chess-state.vala"
				if (_tmp4_ == NULL) {
#line 690 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 690 "../lib/chess-state.vala"
					continue;
#line 3796 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 693 "../lib/chess-state.vala"
				_tmp8_ = _tmp7_->type;
#line 693 "../lib/chess-state.vala"
				if (_tmp8_ == PIECE_TYPE_PAWN) {
#line 693 "../lib/chess-state.vala"
					_tmp6_ = TRUE;
#line 3806 "chess-state.c"
				} else {
					ChessPiece* _tmp9_;
					PieceType _tmp10_;
#line 693 "../lib/chess-state.vala"
					_tmp9_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp10_ = _tmp9_->type;
#line 693 "../lib/chess-state.vala"
					_tmp6_ = _tmp10_ == PIECE_TYPE_ROOK;
#line 3816 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 693 "../lib/chess-state.vala"
					_tmp5_ = TRUE;
#line 3822 "chess-state.c"
				} else {
					ChessPiece* _tmp11_;
					PieceType _tmp12_;
#line 693 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp12_ = _tmp11_->type;
#line 693 "../lib/chess-state.vala"
					_tmp5_ = _tmp12_ == PIECE_TYPE_QUEEN;
#line 3832 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp5_) {
#line 694 "../lib/chess-state.vala"
					result = TRUE;
#line 694 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 694 "../lib/chess-state.vala"
					return result;
#line 3842 "chess-state.c"
				}
#line 697 "../lib/chess-state.vala"
				_tmp13_ = p;
#line 697 "../lib/chess-state.vala"
				_tmp14_ = _tmp13_->type;
#line 697 "../lib/chess-state.vala"
				if (_tmp14_ == PIECE_TYPE_KNIGHT) {
#line 3850 "chess-state.c"
					ChessPiece* _tmp15_;
					Color _tmp16_;
					Color _tmp17_;
#line 699 "../lib/chess-state.vala"
					_tmp15_ = p;
#line 699 "../lib/chess-state.vala"
					_tmp16_ = chess_piece_get_color (_tmp15_);
#line 699 "../lib/chess-state.vala"
					_tmp17_ = _tmp16_;
#line 699 "../lib/chess-state.vala"
					if (_tmp17_ == COLOR_WHITE) {
#line 3862 "chess-state.c"
						gint _tmp18_;
#line 700 "../lib/chess-state.vala"
						_tmp18_ = white_knight_count;
#line 700 "../lib/chess-state.vala"
						white_knight_count = _tmp18_ + 1;
#line 3868 "chess-state.c"
					} else {
						gint _tmp19_;
#line 702 "../lib/chess-state.vala"
						_tmp19_ = black_knight_count;
#line 702 "../lib/chess-state.vala"
						black_knight_count = _tmp19_ + 1;
#line 3875 "chess-state.c"
					}
				}
#line 705 "../lib/chess-state.vala"
				_tmp20_ = p;
#line 705 "../lib/chess-state.vala"
				_tmp21_ = _tmp20_->type;
#line 705 "../lib/chess-state.vala"
				if (_tmp21_ == PIECE_TYPE_BISHOP) {
#line 3884 "chess-state.c"
					Color color = 0;
					ChessPiece* _tmp22_;
					Color _tmp23_;
					Color _tmp24_;
#line 707 "../lib/chess-state.vala"
					color = COLOR_BLACK;
#line 708 "../lib/chess-state.vala"
					if (((i + (i / 8)) % 2) != 0) {
#line 709 "../lib/chess-state.vala"
						color = COLOR_WHITE;
#line 3895 "chess-state.c"
					}
#line 711 "../lib/chess-state.vala"
					_tmp22_ = p;
#line 711 "../lib/chess-state.vala"
					_tmp23_ = chess_piece_get_color (_tmp22_);
#line 711 "../lib/chess-state.vala"
					_tmp24_ = _tmp23_;
#line 711 "../lib/chess-state.vala"
					if (_tmp24_ == COLOR_WHITE) {
#line 3905 "chess-state.c"
						Color _tmp25_;
						gint _tmp26_;
#line 713 "../lib/chess-state.vala"
						_tmp25_ = color;
#line 713 "../lib/chess-state.vala"
						if (_tmp25_ == COLOR_WHITE) {
#line 714 "../lib/chess-state.vala"
							white_bishop_on_white_square = TRUE;
#line 3914 "chess-state.c"
						} else {
#line 716 "../lib/chess-state.vala"
							white_bishop_on_black_square = TRUE;
#line 3918 "chess-state.c"
						}
#line 717 "../lib/chess-state.vala"
						_tmp26_ = white_bishop_count;
#line 717 "../lib/chess-state.vala"
						white_bishop_count = _tmp26_ + 1;
#line 3924 "chess-state.c"
					} else {
						Color _tmp27_;
						gint _tmp28_;
#line 721 "../lib/chess-state.vala"
						_tmp27_ = color;
#line 721 "../lib/chess-state.vala"
						if (_tmp27_ == COLOR_WHITE) {
#line 722 "../lib/chess-state.vala"
							black_bishop_on_white_square = TRUE;
#line 3934 "chess-state.c"
						} else {
#line 724 "../lib/chess-state.vala"
							black_bishop_on_black_square = TRUE;
#line 3938 "chess-state.c"
						}
#line 725 "../lib/chess-state.vala"
						_tmp28_ = black_bishop_count;
#line 725 "../lib/chess-state.vala"
						black_bishop_count = _tmp28_ + 1;
#line 3944 "chess-state.c"
					}
				}
#line 759 "../lib/chess-state.vala"
				if (white_knight_count > 1) {
#line 759 "../lib/chess-state.vala"
					_tmp29_ = TRUE;
#line 3951 "chess-state.c"
				} else {
#line 759 "../lib/chess-state.vala"
					_tmp29_ = black_knight_count > 1;
#line 3955 "chess-state.c"
				}
#line 759 "../lib/chess-state.vala"
				if (_tmp29_) {
#line 760 "../lib/chess-state.vala"
					result = TRUE;
#line 760 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 760 "../lib/chess-state.vala"
					return result;
#line 3965 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 763 "../lib/chess-state.vala"
					_tmp30_ = white_knight_count > 0;
#line 3971 "chess-state.c"
				} else {
#line 763 "../lib/chess-state.vala"
					_tmp30_ = FALSE;
#line 3975 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				if (_tmp30_) {
#line 764 "../lib/chess-state.vala"
					result = TRUE;
#line 764 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 764 "../lib/chess-state.vala"
					return result;
#line 3985 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				if (black_bishop_count > 0) {
#line 765 "../lib/chess-state.vala"
					_tmp31_ = black_knight_count > 0;
#line 3991 "chess-state.c"
				} else {
#line 765 "../lib/chess-state.vala"
					_tmp31_ = FALSE;
#line 3995 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				if (_tmp31_) {
#line 766 "../lib/chess-state.vala"
					result = TRUE;
#line 766 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 766 "../lib/chess-state.vala"
					return result;
#line 4005 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				if (white_bishop_on_white_square) {
#line 769 "../lib/chess-state.vala"
					_tmp32_ = white_bishop_on_black_square;
#line 4011 "chess-state.c"
				} else {
#line 769 "../lib/chess-state.vala"
					_tmp32_ = FALSE;
#line 4015 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				if (_tmp32_) {
#line 770 "../lib/chess-state.vala"
					result = TRUE;
#line 770 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 770 "../lib/chess-state.vala"
					return result;
#line 4025 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				if (black_bishop_on_white_square) {
#line 771 "../lib/chess-state.vala"
					_tmp33_ = black_bishop_on_black_square;
#line 4031 "chess-state.c"
				} else {
#line 771 "../lib/chess-state.vala"
					_tmp33_ = FALSE;
#line 4035 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				if (_tmp33_) {
#line 772 "../lib/chess-state.vala"
					result = TRUE;
#line 772 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 772 "../lib/chess-state.vala"
					return result;
#line 4045 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 775 "../lib/chess-state.vala"
					_tmp35_ = TRUE;
#line 4051 "chess-state.c"
				} else {
#line 775 "../lib/chess-state.vala"
					_tmp35_ = white_knight_count > 0;
#line 4055 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp35_) {
#line 775 "../lib/chess-state.vala"
					_tmp34_ = black_knight_count > 0;
#line 4061 "chess-state.c"
				} else {
#line 775 "../lib/chess-state.vala"
					_tmp34_ = FALSE;
#line 4065 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp34_) {
#line 776 "../lib/chess-state.vala"
					result = TRUE;
#line 776 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 776 "../lib/chess-state.vala"
					return result;
#line 4075 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (black_bishop_count > 0) {
#line 777 "../lib/chess-state.vala"
					_tmp37_ = TRUE;
#line 4081 "chess-state.c"
				} else {
#line 777 "../lib/chess-state.vala"
					_tmp37_ = black_knight_count > 0;
#line 4085 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp37_) {
#line 777 "../lib/chess-state.vala"
					_tmp36_ = white_knight_count > 0;
#line 4091 "chess-state.c"
				} else {
#line 777 "../lib/chess-state.vala"
					_tmp36_ = FALSE;
#line 4095 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp36_) {
#line 778 "../lib/chess-state.vala"
					result = TRUE;
#line 778 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 778 "../lib/chess-state.vala"
					return result;
#line 4105 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 781 "../lib/chess-state.vala"
					_tmp38_ = black_bishop_count > 0;
#line 4111 "chess-state.c"
				} else {
#line 781 "../lib/chess-state.vala"
					_tmp38_ = FALSE;
#line 4115 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				if (_tmp38_) {
#line 4119 "chess-state.c"
					gboolean _tmp39_ = FALSE;
#line 783 "../lib/chess-state.vala"
					if (white_bishop_on_white_square) {
#line 783 "../lib/chess-state.vala"
						_tmp39_ = black_bishop_on_black_square;
#line 4125 "chess-state.c"
					} else {
#line 783 "../lib/chess-state.vala"
						_tmp39_ = FALSE;
#line 4129 "chess-state.c"
					}
#line 783 "../lib/chess-state.vala"
					if (_tmp39_) {
#line 784 "../lib/chess-state.vala"
						result = TRUE;
#line 784 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 784 "../lib/chess-state.vala"
						return result;
#line 4139 "chess-state.c"
					} else {
						gboolean _tmp40_ = FALSE;
#line 785 "../lib/chess-state.vala"
						if (white_bishop_on_black_square) {
#line 785 "../lib/chess-state.vala"
							_tmp40_ = black_bishop_on_white_square;
#line 4146 "chess-state.c"
						} else {
#line 785 "../lib/chess-state.vala"
							_tmp40_ = FALSE;
#line 4150 "chess-state.c"
						}
#line 785 "../lib/chess-state.vala"
						if (_tmp40_) {
#line 786 "../lib/chess-state.vala"
							result = TRUE;
#line 786 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 786 "../lib/chess-state.vala"
							return result;
#line 4160 "chess-state.c"
						}
					}
				}
#line 686 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4166 "chess-state.c"
			}
		}
	}
#line 790 "../lib/chess-state.vala"
	result = FALSE;
#line 790 "../lib/chess-state.vala"
	return result;
#line 4174 "chess-state.c"
}

static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result = FALSE;
#line 793 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../lib/chess-state.vala"
	_vala_type = PIECE_TYPE_PAWN;
#line 796 "../lib/chess-state.vala"
	switch (c) {
#line 796 "../lib/chess-state.vala"
		case 'P':
#line 4192 "chess-state.c"
		{
#line 799 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_PAWN;
#line 800 "../lib/chess-state.vala"
			result = TRUE;
#line 800 "../lib/chess-state.vala"
			if (type) {
#line 800 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4202 "chess-state.c"
			}
#line 800 "../lib/chess-state.vala"
			return result;
#line 4206 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'R':
#line 4210 "chess-state.c"
		{
#line 802 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_ROOK;
#line 803 "../lib/chess-state.vala"
			result = TRUE;
#line 803 "../lib/chess-state.vala"
			if (type) {
#line 803 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4220 "chess-state.c"
			}
#line 803 "../lib/chess-state.vala"
			return result;
#line 4224 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'N':
#line 4228 "chess-state.c"
		{
#line 805 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KNIGHT;
#line 806 "../lib/chess-state.vala"
			result = TRUE;
#line 806 "../lib/chess-state.vala"
			if (type) {
#line 806 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4238 "chess-state.c"
			}
#line 806 "../lib/chess-state.vala"
			return result;
#line 4242 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'B':
#line 4246 "chess-state.c"
		{
#line 808 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_BISHOP;
#line 809 "../lib/chess-state.vala"
			result = TRUE;
#line 809 "../lib/chess-state.vala"
			if (type) {
#line 809 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4256 "chess-state.c"
			}
#line 809 "../lib/chess-state.vala"
			return result;
#line 4260 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'Q':
#line 4264 "chess-state.c"
		{
#line 811 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_QUEEN;
#line 812 "../lib/chess-state.vala"
			result = TRUE;
#line 812 "../lib/chess-state.vala"
			if (type) {
#line 812 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4274 "chess-state.c"
			}
#line 812 "../lib/chess-state.vala"
			return result;
#line 4278 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'K':
#line 4282 "chess-state.c"
		{
#line 814 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KING;
#line 815 "../lib/chess-state.vala"
			result = TRUE;
#line 815 "../lib/chess-state.vala"
			if (type) {
#line 815 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4292 "chess-state.c"
			}
#line 815 "../lib/chess-state.vala"
			return result;
#line 4296 "chess-state.c"
		}
		default:
		{
#line 817 "../lib/chess-state.vala"
			result = FALSE;
#line 817 "../lib/chess-state.vala"
			if (type) {
#line 817 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4306 "chess-state.c"
			}
#line 817 "../lib/chess-state.vala"
			return result;
#line 4310 "chess-state.c"
		}
	}
#line 793 "../lib/chess-state.vala"
	if (type) {
#line 793 "../lib/chess-state.vala"
		*type = _vala_type;
#line 4317 "chess-state.c"
	}
}

static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gboolean result = FALSE;
	gint i = 0;
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 823 "../lib/chess-state.vala"
	i = 0;
#line 825 "../lib/chess-state.vala"
	_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 826 "../lib/chess-state.vala"
	if (g_str_has_prefix (move, "O-O-O")) {
#line 4350 "chess-state.c"
		Color _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 828 "../lib/chess-state.vala"
		_tmp0_ = player->color;
#line 828 "../lib/chess-state.vala"
		if (_tmp0_ == COLOR_WHITE) {
#line 829 "../lib/chess-state.vala"
			_vala_r1 = 0;
#line 829 "../lib/chess-state.vala"
			_vala_r0 = _vala_r1;
#line 4362 "chess-state.c"
		} else {
#line 831 "../lib/chess-state.vala"
			_vala_r1 = 7;
#line 831 "../lib/chess-state.vala"
			_vala_r0 = _vala_r1;
#line 4368 "chess-state.c"
		}
#line 832 "../lib/chess-state.vala"
		_vala_f0 = 4;
#line 833 "../lib/chess-state.vala"
		_vala_f1 = 2;
#line 834 "../lib/chess-state.vala"
		_tmp1_ = strlen ("O-O-O");
#line 834 "../lib/chess-state.vala"
		_tmp2_ = _tmp1_;
#line 834 "../lib/chess-state.vala"
		i = i + ((gint) _tmp2_);
#line 4380 "chess-state.c"
	} else {
#line 836 "../lib/chess-state.vala"
		if (g_str_has_prefix (move, "O-O")) {
#line 4384 "chess-state.c"
			Color _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 838 "../lib/chess-state.vala"
			_tmp3_ = player->color;
#line 838 "../lib/chess-state.vala"
			if (_tmp3_ == COLOR_WHITE) {
#line 839 "../lib/chess-state.vala"
				_vala_r1 = 0;
#line 839 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 4396 "chess-state.c"
			} else {
#line 841 "../lib/chess-state.vala"
				_vala_r1 = 7;
#line 841 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 4402 "chess-state.c"
			}
#line 842 "../lib/chess-state.vala"
			_vala_f0 = 4;
#line 843 "../lib/chess-state.vala"
			_vala_f1 = 6;
#line 844 "../lib/chess-state.vala"
			_tmp4_ = strlen ("O-O");
#line 844 "../lib/chess-state.vala"
			_tmp5_ = _tmp4_;
#line 844 "../lib/chess-state.vala"
			i = i + ((gint) _tmp5_);
#line 4414 "chess-state.c"
		} else {
			PieceType type = 0;
			PieceType _tmp6_ = 0;
			gboolean _tmp7_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp27_ = FALSE;
			gboolean _tmp28_ = FALSE;
#line 848 "../lib/chess-state.vala"
			type = PIECE_TYPE_PAWN;
#line 849 "../lib/chess-state.vala"
			_tmp7_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp6_);
#line 849 "../lib/chess-state.vala"
			type = _tmp6_;
#line 849 "../lib/chess-state.vala"
			if (_tmp7_) {
#line 4434 "chess-state.c"
				gint _tmp8_;
#line 850 "../lib/chess-state.vala"
				_tmp8_ = i;
#line 850 "../lib/chess-state.vala"
				i = _tmp8_ + 1;
#line 4440 "chess-state.c"
			}
#line 852 "../lib/chess-state.vala"
			_vala_f1 = -1;
#line 852 "../lib/chess-state.vala"
			_vala_r1 = _vala_f1;
#line 852 "../lib/chess-state.vala"
			_vala_f0 = _vala_r1;
#line 852 "../lib/chess-state.vala"
			_vala_r0 = _vala_f0;
#line 853 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= 'a') {
#line 853 "../lib/chess-state.vala"
				_tmp9_ = string_get (move, (glong) i) <= 'h';
#line 4454 "chess-state.c"
			} else {
#line 853 "../lib/chess-state.vala"
				_tmp9_ = FALSE;
#line 4458 "chess-state.c"
			}
#line 853 "../lib/chess-state.vala"
			if (_tmp9_) {
#line 4462 "chess-state.c"
				gint _tmp10_;
#line 855 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
#line 856 "../lib/chess-state.vala"
				_tmp10_ = i;
#line 856 "../lib/chess-state.vala"
				i = _tmp10_ + 1;
#line 4470 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= '1') {
#line 858 "../lib/chess-state.vala"
				_tmp11_ = string_get (move, (glong) i) <= '8';
#line 4476 "chess-state.c"
			} else {
#line 858 "../lib/chess-state.vala"
				_tmp11_ = FALSE;
#line 4480 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			if (_tmp11_) {
#line 4484 "chess-state.c"
				gint _tmp12_;
#line 860 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
#line 861 "../lib/chess-state.vala"
				_tmp12_ = i;
#line 861 "../lib/chess-state.vala"
				i = _tmp12_ + 1;
#line 4492 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) == 'x') {
#line 863 "../lib/chess-state.vala"
				_tmp13_ = TRUE;
#line 4498 "chess-state.c"
			} else {
#line 863 "../lib/chess-state.vala"
				_tmp13_ = string_get (move, (glong) i) == '-';
#line 4502 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			if (_tmp13_) {
#line 4506 "chess-state.c"
				gint _tmp14_;
#line 864 "../lib/chess-state.vala"
				_tmp14_ = i;
#line 864 "../lib/chess-state.vala"
				i = _tmp14_ + 1;
#line 4512 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= 'a') {
#line 865 "../lib/chess-state.vala"
				_tmp15_ = string_get (move, (glong) i) <= 'h';
#line 4518 "chess-state.c"
			} else {
#line 865 "../lib/chess-state.vala"
				_tmp15_ = FALSE;
#line 4522 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			if (_tmp15_) {
#line 4526 "chess-state.c"
				gint _tmp16_;
#line 867 "../lib/chess-state.vala"
				_vala_f0 = _vala_f1;
#line 868 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
#line 869 "../lib/chess-state.vala"
				_tmp16_ = i;
#line 869 "../lib/chess-state.vala"
				i = _tmp16_ + 1;
#line 4536 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= '1') {
#line 871 "../lib/chess-state.vala"
				_tmp17_ = string_get (move, (glong) i) <= '8';
#line 4542 "chess-state.c"
			} else {
#line 871 "../lib/chess-state.vala"
				_tmp17_ = FALSE;
#line 4546 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			if (_tmp17_) {
#line 4550 "chess-state.c"
				gint _tmp18_;
#line 873 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 874 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
#line 875 "../lib/chess-state.vala"
				_tmp18_ = i;
#line 875 "../lib/chess-state.vala"
				i = _tmp18_ + 1;
#line 4560 "chess-state.c"
			}
#line 877 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) == '=') {
#line 4564 "chess-state.c"
				gint _tmp19_;
				PieceType _tmp20_ = 0;
				gboolean _tmp21_;
#line 879 "../lib/chess-state.vala"
				_tmp19_ = i;
#line 879 "../lib/chess-state.vala"
				i = _tmp19_ + 1;
#line 880 "../lib/chess-state.vala"
				_tmp21_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp20_);
#line 880 "../lib/chess-state.vala"
				_vala_promotion_type = _tmp20_;
#line 880 "../lib/chess-state.vala"
				if (_tmp21_) {
#line 4578 "chess-state.c"
					gint _tmp22_;
#line 881 "../lib/chess-state.vala"
					_tmp22_ = i;
#line 881 "../lib/chess-state.vala"
					i = _tmp22_ + 1;
#line 4584 "chess-state.c"
				}
			} else {
#line 883 "../lib/chess-state.vala"
				if (string_get (move, (glong) i) != '\0') {
#line 885 "../lib/chess-state.vala"
					switch (string_get (move, (glong) i)) {
#line 885 "../lib/chess-state.vala"
						case 'q':
#line 885 "../lib/chess-state.vala"
						case 'Q':
#line 4595 "chess-state.c"
						{
							gint _tmp23_;
#line 889 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 890 "../lib/chess-state.vala"
							_tmp23_ = i;
#line 890 "../lib/chess-state.vala"
							i = _tmp23_ + 1;
#line 891 "../lib/chess-state.vala"
							break;
#line 4606 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'n':
#line 885 "../lib/chess-state.vala"
						case 'N':
#line 4612 "chess-state.c"
						{
							gint _tmp24_;
#line 894 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
#line 895 "../lib/chess-state.vala"
							_tmp24_ = i;
#line 895 "../lib/chess-state.vala"
							i = _tmp24_ + 1;
#line 896 "../lib/chess-state.vala"
							break;
#line 4623 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'r':
#line 885 "../lib/chess-state.vala"
						case 'R':
#line 4629 "chess-state.c"
						{
							gint _tmp25_;
#line 899 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_ROOK;
#line 900 "../lib/chess-state.vala"
							_tmp25_ = i;
#line 900 "../lib/chess-state.vala"
							i = _tmp25_ + 1;
#line 901 "../lib/chess-state.vala"
							break;
#line 4640 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'b':
#line 885 "../lib/chess-state.vala"
						case 'B':
#line 4646 "chess-state.c"
						{
							gint _tmp26_;
#line 904 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_BISHOP;
#line 905 "../lib/chess-state.vala"
							_tmp26_ = i;
#line 905 "../lib/chess-state.vala"
							i = _tmp26_ + 1;
#line 906 "../lib/chess-state.vala"
							break;
#line 4657 "chess-state.c"
						}
						default:
#line 885 "../lib/chess-state.vala"
						break;
#line 4662 "chess-state.c"
					}
				}
			}
#line 911 "../lib/chess-state.vala"
			if (_vala_r1 < 0) {
#line 911 "../lib/chess-state.vala"
				_tmp27_ = TRUE;
#line 4670 "chess-state.c"
			} else {
#line 911 "../lib/chess-state.vala"
				_tmp27_ = _vala_f1 < 0;
#line 4674 "chess-state.c"
			}
#line 911 "../lib/chess-state.vala"
			if (_tmp27_) {
#line 913 "../lib/chess-state.vala"
				g_debug ("chess-state.vala:913: Move %s missing destination", move);
#line 914 "../lib/chess-state.vala"
				result = FALSE;
#line 914 "../lib/chess-state.vala"
				if (r0) {
#line 914 "../lib/chess-state.vala"
					*r0 = _vala_r0;
#line 4686 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f0) {
#line 914 "../lib/chess-state.vala"
					*f0 = _vala_f0;
#line 4692 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (r1) {
#line 914 "../lib/chess-state.vala"
					*r1 = _vala_r1;
#line 4698 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f1) {
#line 914 "../lib/chess-state.vala"
					*f1 = _vala_f1;
#line 4704 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (promotion_type) {
#line 914 "../lib/chess-state.vala"
					*promotion_type = _vala_promotion_type;
#line 4710 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				return result;
#line 4714 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			if (_vala_r0 < 0) {
#line 918 "../lib/chess-state.vala"
				_tmp28_ = TRUE;
#line 4720 "chess-state.c"
			} else {
#line 918 "../lib/chess-state.vala"
				_tmp28_ = _vala_f0 < 0;
#line 4724 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			if (_tmp28_) {
#line 4728 "chess-state.c"
				gint match_rank = 0;
				gint match_file = 0;
#line 920 "../lib/chess-state.vala"
				match_rank = -1;
#line 920 "../lib/chess-state.vala"
				match_file = -1;
#line 4735 "chess-state.c"
				{
					gint file = 0;
#line 922 "../lib/chess-state.vala"
					file = 0;
#line 4740 "chess-state.c"
					{
						gboolean _tmp29_ = FALSE;
#line 922 "../lib/chess-state.vala"
						_tmp29_ = TRUE;
#line 922 "../lib/chess-state.vala"
						while (TRUE) {
#line 4747 "chess-state.c"
							gboolean _tmp31_ = FALSE;
#line 922 "../lib/chess-state.vala"
							if (!_tmp29_) {
#line 4751 "chess-state.c"
								gint _tmp30_;
#line 922 "../lib/chess-state.vala"
								_tmp30_ = file;
#line 922 "../lib/chess-state.vala"
								file = _tmp30_ + 1;
#line 4757 "chess-state.c"
							}
#line 922 "../lib/chess-state.vala"
							_tmp29_ = FALSE;
#line 922 "../lib/chess-state.vala"
							if (!(file < 8)) {
#line 922 "../lib/chess-state.vala"
								break;
#line 4765 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							if (_vala_f0 >= 0) {
#line 924 "../lib/chess-state.vala"
								_tmp31_ = file != _vala_f0;
#line 4771 "chess-state.c"
							} else {
#line 924 "../lib/chess-state.vala"
								_tmp31_ = FALSE;
#line 4775 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							if (_tmp31_) {
#line 925 "../lib/chess-state.vala"
								continue;
#line 4781 "chess-state.c"
							}
							{
								gint rank = 0;
#line 927 "../lib/chess-state.vala"
								rank = 0;
#line 4787 "chess-state.c"
								{
									gboolean _tmp32_ = FALSE;
#line 927 "../lib/chess-state.vala"
									_tmp32_ = TRUE;
#line 927 "../lib/chess-state.vala"
									while (TRUE) {
#line 4794 "chess-state.c"
										gboolean _tmp34_ = FALSE;
										ChessPiece* piece = NULL;
										ChessPiece* _tmp35_;
										ChessPiece* _tmp36_;
										gboolean _tmp37_ = FALSE;
										gboolean _tmp38_ = FALSE;
										ChessPiece* _tmp39_;
#line 927 "../lib/chess-state.vala"
										if (!_tmp32_) {
#line 4804 "chess-state.c"
											gint _tmp33_;
#line 927 "../lib/chess-state.vala"
											_tmp33_ = rank;
#line 927 "../lib/chess-state.vala"
											rank = _tmp33_ + 1;
#line 4810 "chess-state.c"
										}
#line 927 "../lib/chess-state.vala"
										_tmp32_ = FALSE;
#line 927 "../lib/chess-state.vala"
										if (!(rank < 8)) {
#line 927 "../lib/chess-state.vala"
											break;
#line 4818 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										if (_vala_r0 >= 0) {
#line 929 "../lib/chess-state.vala"
											_tmp34_ = rank != _vala_r0;
#line 4824 "chess-state.c"
										} else {
#line 929 "../lib/chess-state.vala"
											_tmp34_ = FALSE;
#line 4828 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										if (_tmp34_) {
#line 930 "../lib/chess-state.vala"
											continue;
#line 4834 "chess-state.c"
										}
#line 933 "../lib/chess-state.vala"
										_tmp35_ = self->board[chess_state_get_index (self, rank, file)];
#line 933 "../lib/chess-state.vala"
										_tmp36_ = _g_object_ref0 (_tmp35_);
#line 933 "../lib/chess-state.vala"
										piece = _tmp36_;
#line 934 "../lib/chess-state.vala"
										_tmp39_ = piece;
#line 934 "../lib/chess-state.vala"
										if (_tmp39_ == NULL) {
#line 934 "../lib/chess-state.vala"
											_tmp38_ = TRUE;
#line 4848 "chess-state.c"
										} else {
											ChessPiece* _tmp40_;
											PieceType _tmp41_;
											PieceType _tmp42_;
#line 934 "../lib/chess-state.vala"
											_tmp40_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp41_ = _tmp40_->type;
#line 934 "../lib/chess-state.vala"
											_tmp42_ = type;
#line 934 "../lib/chess-state.vala"
											_tmp38_ = _tmp41_ != _tmp42_;
#line 4861 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp38_) {
#line 934 "../lib/chess-state.vala"
											_tmp37_ = TRUE;
#line 4867 "chess-state.c"
										} else {
											ChessPiece* _tmp43_;
											ChessPlayer* _tmp44_;
#line 934 "../lib/chess-state.vala"
											_tmp43_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp44_ = _tmp43_->player;
#line 934 "../lib/chess-state.vala"
											_tmp37_ = _tmp44_ != player;
#line 4877 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp37_) {
#line 935 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 935 "../lib/chess-state.vala"
											continue;
#line 4885 "chess-state.c"
										}
#line 938 "../lib/chess-state.vala"
										if (!chess_state_move_with_coords (self, player, rank, file, _vala_r1, _vala_f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 939 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 939 "../lib/chess-state.vala"
											continue;
#line 4893 "chess-state.c"
										}
#line 942 "../lib/chess-state.vala"
										if (match_rank >= 0) {
#line 944 "../lib/chess-state.vala"
											g_debug ("chess-state.vala:944: Move %s is ambiguous", move);
#line 945 "../lib/chess-state.vala"
											result = FALSE;
#line 945 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 945 "../lib/chess-state.vala"
											if (r0) {
#line 945 "../lib/chess-state.vala"
												*r0 = _vala_r0;
#line 4907 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f0) {
#line 945 "../lib/chess-state.vala"
												*f0 = _vala_f0;
#line 4913 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (r1) {
#line 945 "../lib/chess-state.vala"
												*r1 = _vala_r1;
#line 4919 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f1) {
#line 945 "../lib/chess-state.vala"
												*f1 = _vala_f1;
#line 4925 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (promotion_type) {
#line 945 "../lib/chess-state.vala"
												*promotion_type = _vala_promotion_type;
#line 4931 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											return result;
#line 4935 "chess-state.c"
										}
#line 948 "../lib/chess-state.vala"
										match_rank = rank;
#line 949 "../lib/chess-state.vala"
										match_file = file;
#line 927 "../lib/chess-state.vala"
										_g_object_unref0 (piece);
#line 4943 "chess-state.c"
									}
								}
							}
						}
					}
				}
#line 953 "../lib/chess-state.vala"
				if (match_rank < 0) {
#line 955 "../lib/chess-state.vala"
					g_debug ("chess-state.vala:955: Move %s has no matches", move);
#line 956 "../lib/chess-state.vala"
					result = FALSE;
#line 956 "../lib/chess-state.vala"
					if (r0) {
#line 956 "../lib/chess-state.vala"
						*r0 = _vala_r0;
#line 4960 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f0) {
#line 956 "../lib/chess-state.vala"
						*f0 = _vala_f0;
#line 4966 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (r1) {
#line 956 "../lib/chess-state.vala"
						*r1 = _vala_r1;
#line 4972 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f1) {
#line 956 "../lib/chess-state.vala"
						*f1 = _vala_f1;
#line 4978 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (promotion_type) {
#line 956 "../lib/chess-state.vala"
						*promotion_type = _vala_promotion_type;
#line 4984 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					return result;
#line 4988 "chess-state.c"
				}
#line 959 "../lib/chess-state.vala"
				_vala_r0 = match_rank;
#line 960 "../lib/chess-state.vala"
				_vala_f0 = match_file;
#line 4994 "chess-state.c"
			}
		}
	}
#line 964 "../lib/chess-state.vala"
	if (string_get (move, (glong) i) == '+') {
#line 5000 "chess-state.c"
		gint _tmp45_;
#line 965 "../lib/chess-state.vala"
		_tmp45_ = i;
#line 965 "../lib/chess-state.vala"
		i = _tmp45_ + 1;
#line 5006 "chess-state.c"
	} else {
#line 966 "../lib/chess-state.vala"
		if (string_get (move, (glong) i) == '#') {
#line 5010 "chess-state.c"
			gint _tmp46_;
#line 967 "../lib/chess-state.vala"
			_tmp46_ = i;
#line 967 "../lib/chess-state.vala"
			i = _tmp46_ + 1;
#line 5016 "chess-state.c"
		}
	}
#line 969 "../lib/chess-state.vala"
	if (string_get (move, (glong) i) != '\0') {
#line 971 "../lib/chess-state.vala"
		g_debug ("chess-state.vala:971: Move %s has unexpected characters", move);
#line 972 "../lib/chess-state.vala"
		result = FALSE;
#line 972 "../lib/chess-state.vala"
		if (r0) {
#line 972 "../lib/chess-state.vala"
			*r0 = _vala_r0;
#line 5029 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f0) {
#line 972 "../lib/chess-state.vala"
			*f0 = _vala_f0;
#line 5035 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (r1) {
#line 972 "../lib/chess-state.vala"
			*r1 = _vala_r1;
#line 5041 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f1) {
#line 972 "../lib/chess-state.vala"
			*f1 = _vala_f1;
#line 5047 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (promotion_type) {
#line 972 "../lib/chess-state.vala"
			*promotion_type = _vala_promotion_type;
#line 5053 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		return result;
#line 5057 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	result = TRUE;
#line 975 "../lib/chess-state.vala"
	if (r0) {
#line 975 "../lib/chess-state.vala"
		*r0 = _vala_r0;
#line 5065 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f0) {
#line 975 "../lib/chess-state.vala"
		*f0 = _vala_f0;
#line 5071 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (r1) {
#line 975 "../lib/chess-state.vala"
		*r1 = _vala_r1;
#line 5077 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f1) {
#line 975 "../lib/chess-state.vala"
		*f1 = _vala_f1;
#line 5083 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (promotion_type) {
#line 975 "../lib/chess-state.vala"
		*promotion_type = _vala_promotion_type;
#line 5089 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	return result;
#line 5093 "chess-state.c"
}

ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
	Color _tmp2_;
#line 27 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 27 "../lib/chess-state.vala"
	_tmp2_ = _tmp1_->color;
#line 27 "../lib/chess-state.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 5111 "chess-state.c"
		ChessPlayer* _tmp3_;
#line 27 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_BLACK];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 5117 "chess-state.c"
	} else {
		ChessPlayer* _tmp4_;
#line 27 "../lib/chess-state.vala"
		_tmp4_ = self->players[COLOR_WHITE];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp4_;
#line 5124 "chess-state.c"
	}
#line 27 "../lib/chess-state.vala"
	result = _tmp0_;
#line 27 "../lib/chess-state.vala"
	return result;
#line 5130 "chess-state.c"
}

static void
chess_state_class_init (ChessStateClass * klass,
                        gpointer klass_data)
{
#line 20 "../lib/chess-state.vala"
	chess_state_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/chess-state.vala"
	g_type_class_adjust_private_offset (klass, &ChessState_private_offset);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
#line 20 "../lib/chess-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5147 "chess-state.c"
}

static void
chess_state_instance_init (ChessState * self,
                           gpointer klass)
{
#line 20 "../lib/chess-state.vala"
	self->priv = chess_state_get_instance_private (self);
#line 22 "../lib/chess-state.vala"
	self->number = 0;
#line 31 "../lib/chess-state.vala"
	self->en_passant_index = -1;
#line 36 "../lib/chess-state.vala"
	self->last_move = NULL;
#line 5162 "chess-state.c"
}

static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
#line 20 "../lib/chess-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
#line 23 "../lib/chess-state.vala"
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
#line 24 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 35 "../lib/chess-state.vala"
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
#line 36 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
#line 5181 "chess-state.c"
}

GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__volatile = 0;
	if (g_once_init_enter (&chess_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
		GType chess_state_type_id;
		chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
		ChessState_private_offset = g_type_add_instance_private (chess_state_type_id, sizeof (ChessStatePrivate));
		g_once_init_leave (&chess_state_type_id__volatile, chess_state_type_id);
	}
	return chess_state_type_id__volatile;
}

static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
#line 20 "../lib/chess-state.vala"
	switch (property_id) {
#line 20 "../lib/chess-state.vala"
		case CHESS_STATE_OPPONENT_PROPERTY:
#line 20 "../lib/chess-state.vala"
		g_value_set_object (value, chess_state_get_opponent (self));
#line 20 "../lib/chess-state.vala"
		break;
#line 5214 "chess-state.c"
		default:
#line 20 "../lib/chess-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/chess-state.vala"
		break;
#line 5220 "chess-state.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

